#include <dirent.h>
#include <sys/stat.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/wait.h>

#include <iomanip>
using std::setw;

#include <cmath>
#include <limits.h>
#include <float.h>
#include <string>
#include <iostream>
#include <sstream> 




/*
Copyright (c) 2007, I. B. Smirnov

This program can be used, copied, modified, and distributed
according to the terms of GNU General Public License version 3
published by the Free Software Foundation 29 June 2007,
and provided that the above copyright notice, this permission notice, 
and notices about any modifications of the original text 
appear in all copies and in supporting documentation.
The file is provided "as is" without express or implied warranty.
*/



using std::ostream;

using std::cout;
class indentation
{public:
  int n;
  int s_not;
  indentation(void){ n=0; }
};

extern indentation indn;

inline ostream& operator<<(ostream& file, indentation& ind)
{
  int n;
  if(ind.s_not==1)
    ind.s_not=0;
  else
    for(n=0; n<ind.n; n++) file<<' ';
  return file;
}

ostream& noindent(ostream& f);
ostream& yesindent(ostream& f);
extern int s_short_output;
indentation indn;

ostream& noindent(ostream& f)
{
  indn.s_not=1;
  return f;
}
ostream& yesindent(ostream& f)
{
  indn.s_not=0;
  return f;
}
int s_short_output=0;
class ExcFromSpexit
{public:
  ExcFromSpexit(void){;}
};

void spexit_action(ostream& file);
extern int s_throw_exception_in_spexit;

extern int s_exit_without_core;







const int pqname=1000;
class FunNameStack
{
public:
  static FunNameStack& instance();






  FunNameStack( const FunNameStack& f);
  FunNameStack& operator=(const FunNameStack& f);

  FunNameStack(void);
private:
  int qname;
  char* name[pqname];

  int s_init;



  int s_act;

public:
  int s_print;






private:
  int nmode;
  ostream& printname(ostream& file, int n);

public:
  void set_parameters(int fs_act=1, int fs_print=0);
  ~FunNameStack();
private:
  void printput(ostream& file);
  void printdel(ostream& file);
public:



  inline int put(const char* fname);

  inline void del(int nname);
  friend ostream& operator<<(ostream& file, const FunNameStack& f);
};
ostream& operator<<(ostream& file, const FunNameStack& f);





class FunNameStack_Assist
{
public:
  FunNameStack_Assist(int fs_act=1, int fs_print=0)
  {
    FunNameStack::instance().set_parameters(fs_act=1, fs_print);
  }
};
class FunNameWatch
{
  int nname;
  const char* name;

public:
  inline FunNameWatch(const char* fname);
  inline ~FunNameWatch();
  ostream& hdr(ostream& file) const
    { file<<name<<": "; return file; }
  ostream& whdr(ostream& file) const
    { file<<name<<": WARNING:\n"; return file;}
  ostream& ehdr(ostream& file) const
    { file<<name<<": ERROR:\n"; return file;}
};
ostream& operator<<(ostream& file, const FunNameWatch& f);




class GenError: public FunNameStack
{public:
  GenError(const FunNameStack& f): FunNameStack(f) {;}
  GenError(const GenError& f): FunNameStack(f) {;}
  virtual void print(ostream& file);
  virtual void finish(ostream& file);
  virtual ~GenError() {}
};
using std::cerr;

int FunNameStack::put(const char* fname)
{

  if(s_act != 1) return 0;
  if(qname >= pqname)
  {
    cerr<<"FunNameStack::put: error: qname == pqname\n";
    cerr<<"Most oftenly this happens due to infinite recursion.\n";
    cerr<<"*this="<<(*this);
    exit(1);
  }
  name[qname++] = const_cast< char* > ( fname );
  if(s_print>0) { printput(cout); }
  return qname-1;

}

void FunNameStack::del(int nname)
{
  if(s_act != 1) return ;
  if(nname != qname-1)
  {
    qname = nname;

  }
  else
  {
    if(s_print>0) { printdel(cout); }
    qname--;
  }

}

FunNameWatch::FunNameWatch(const char* fname):name(fname)
{

  nname = FunNameStack::instance().put(fname);



}
FunNameWatch::~FunNameWatch()
{

  if( nname>=0)
     FunNameStack::instance().del(nname);

}
using namespace std;
 typedef std::string String;
inline String long_to_String(long n)



{ std::ostringstream s; s << n; return String(s.str()); }





inline void put_one_n(std::ostringstream& ost)
{
  long qost = ost.str().length();
  if(qost > 0)
  {
    if(ost.str()[qost-1] == '\n')
    {
    }
    else
    {
      ost<<'\n';
    }
  }
  else
    ost<<'\n';
}
enum Pilfer { steal };
const double dbl_min_e_exp = (DBL_MIN_EXP-1) * log(double(FLT_RADIX));
const double dbl_max_e_exp = (DBL_MAX_EXP-1) * log(double(FLT_RADIX));
const double dbl_max_square = sqrt(DBL_MAX);

const double dbl_max_pow3 = pow(DBL_MAX, 1.0/3.0);


const double flt_min_e_exp = (FLT_MIN_EXP-1) * log(double(FLT_RADIX));
const double flt_max_e_exp = (FLT_MAX_EXP-1) * log(double(FLT_RADIX));
const double flt_max_square = sqrt(FLT_MAX);

const double flt_max_pow3 = pow(FLT_MAX, float(1.0/3.0));
inline double find_min( double a, double b) { return (a<b ? a : b ); }
inline double find_max( double a, double b) { return (a>b ? a : b ); }
inline float find_min( float a, float b) { return (a<b ? a : b ); }
inline float find_max( float a, float b) { return (a>b ? a : b ); }
inline long find_min( long a, long b) { return (a<b ? a : b ); }
inline long find_max( long a, long b) { return (a>b ? a : b ); }
inline int find_min( int a, int b) { return (a<b ? a : b ); }
inline int find_max( int a, int b) { return (a>b ? a : b ); }

inline long left_round(double f)
{
  if(f>=0) return long(f);
  else return -long(-f)-1;
}
inline int even_num(long n)
{
  long v=n/2;
  long n1=v*2;
  if(n == n1) return 1;
  else return 0;
}

inline int check_value_inside_bounds(double val, double b1, double b2 )
{ return ((val > b1 && val < b2) ? 1 : 0) ; }
inline int check_value_inside_bounds(float val, float b1, float b2 )
{ return ((val > b1 && val < b2) ? 1 : 0) ; }
inline int check_value_inside_bounds(long val, long b1, long b2 )
{ return ((val > b1 && val < b2) ? 1 : 0) ; }
inline int check_value_inside_bounds(int val, int b1, int b2 )
{ return ((val > b1 && val < b2) ? 1 : 0) ; }

inline int check_value_in_bounds(double val, double b1, double b2 )
{ return ((val >= b1 && val <= b2) ? 1 : 0) ; }
inline int check_value_in_bounds(float val, float b1, float b2 )
{ return ((val >= b1 && val <= b2) ? 1 : 0) ; }
inline int check_value_in_bounds(long val, long b1, long b2 )
{ return ((val >= b1 && val <= b2) ? 1 : 0) ; }
inline int check_value_in_bounds(int val, int b1, int b2 )
{ return ((val >= b1 && val <= b2) ? 1 : 0) ; }

inline int check_value_inside_bounds(double val, double b[2])
{ return ((val > b[0] && val < b[1]) ? 1 : 0) ; }
inline int check_value_inside_bounds(float val, float b[2] )
{ return ((val > b[0] && val < b[1]) ? 1 : 0) ; }
inline int check_value_inside_bounds(long val, long b[2] )
{ return ((val > b[0] && val < b[1]) ? 1 : 0) ; }
inline int check_value_inside_bounds(int val, int b[2] )
{ return ((val > b[0] && val < b[1]) ? 1 : 0) ; }

inline int check_value_in_bounds(double val, double b[2] )
{ return ((val >= b[0] && val <= b[1]) ? 1 : 0) ; }
inline int check_value_in_bounds(float val, float b[2] )
{ return ((val >= b[0] && val <= b[1]) ? 1 : 0) ; }
inline int check_value_in_bounds(long val, long b[2] )
{ return ((val >= b[0] && val <= b[1]) ? 1 : 0) ; }
inline int check_value_in_bounds(int val, int b[2] )
{ return ((val >= b[0] && val <= b[1]) ? 1 : 0) ; }
template<class T>
inline void fcopy(T ar_source, T ar_dest, long q)
{
  long n;
  for( n=0; n<q; n++) ar_dest[n] = ar_source[n];
}

template<class T>
inline void arr_copy(const T* ar_source, T* ar_dest, long q)
{
  long n;
  for( n=0; n<q; n++) ar_dest[n] = ar_source[n];
}

template<class T>
inline void arr_assign(const T source, T* ar_dest, long q)
{
  long n;
  for( n=0; n<q; n++) ar_dest[n] = source;
}

template<class T>
inline long fmax_ar(T ar, long q)
{
  if( q <= 0 )
  {
    cout<<"inline long fmax_ar(T ar, long q): q<=0\n";
    {cout<<FunNameStack::instance(); cout<<"File is "<<"/home/ismirnov/s06/wcpplib/math/minmax.h"<<" , line number is "<<185<<'\n'; spexit_action(cout); };
  }
  long nmval=0;
  long n;
  for( n=1; n<q; n++)
  {
    if(ar[n]>ar[nmval]) { nmval=n; }
  }
  return nmval;
}

template<class T>
inline T tabs(const T& x)
{
  return x >= 0 ? x : -x;
}

template<class T>
int apeq_mant(const T& x1, const T& x2, T prec)
{
  if(x1 == x2) return 1;
  if(prec == 0) return 0;
  if(x1 == 0 && x2 == 0) return 1;
  if(x1 < 0 && x2 > 0 || x1 > 0 && x2 < 0) return 0;
  if(tabs((x1 - x2)/(x1 + x2))<= prec) return 1;
  return 0;
}



extern long max_qel_DynLinArr;





template<class T>class DynArr;




class ArgInterp_Arr
{ };

class ArgInterp_SingleAdr
{ };





class ArgInterp_Val
{ };






template<class T>class DynLinArr

{public:
  DynLinArr(void): qel(0), el(NULL) {;}
  explicit DynLinArr(long fqel): qel(fqel),
    el( NULL )
  {
    if(qel > max_qel_DynLinArr)
    {
      cout<<"ERROR in DynLinArr(long fqel):\n";
      cout<<"qel > max_qel_DynLinArr:\n";
      cout<<indn<<"qel"<<"="<<noindent<<qel<<", "<<"max_qel_DynLinArr"<<"="<<noindent<<max_qel_DynLinArr<<'\n'<<yesindent;;
      cout<<"Type of T is (in internal notations) "<<typeid(T).name()<<'\n';
      {cout<<FunNameStack::instance(); cout<<"File is "<<"/home/ismirnov/s06/wcpplib/safetl/AbsArr.h"<<" , line number is "<<167<<'\n'; spexit_action(cout); };
    }
    if(qel < 0)
    {
      cout<<"ERROR in DynLinArr(long fqel):\n";
      cout<<"qel < 0:\n";
      cout<<indn<<"qel"<<"="<<noindent<<qel<<'\n'<<yesindent;;
      cout<<"Type of T is (in internal notations) "<<typeid(T).name()<<'\n';
      {cout<<FunNameStack::instance(); cout<<"File is "<<"/home/ismirnov/s06/wcpplib/safetl/AbsArr.h"<<" , line number is "<<175<<'\n'; spexit_action(cout); };
    }
    el = (fqel > 0) ? (new T[fqel]) : (T*)NULL;

  }

  DynLinArr(long fqel, const T& val): qel(fqel),
      el( NULL )
  {
    if(qel > max_qel_DynLinArr)
    {
      cout<<"ERROR in DynLinArr(long fqel, const T& val):\n";
      cout<<"qel > max_qel_DynLinArr:\n";
      cout<<indn<<"qel"<<"="<<noindent<<qel<<", "<<"max_qel_DynLinArr"<<"="<<noindent<<max_qel_DynLinArr<<'\n'<<yesindent;;
      cout<<"Type of T is (in internal notations) "<<typeid(T).name()<<'\n';
      {cout<<FunNameStack::instance(); cout<<"File is "<<"/home/ismirnov/s06/wcpplib/safetl/AbsArr.h"<<" , line number is "<<200<<'\n'; spexit_action(cout); };
    }
    if(qel < 0)
    {
      cout<<"ERROR in DynLinArr(long fqel, const T& val):\n";
      cout<<"qel < 0:\n";
      cout<<indn<<"qel"<<"="<<noindent<<qel<<'\n'<<yesindent;;
      cout<<"Type of T is (in internal notations) "<<typeid(T).name()<<'\n';
      {cout<<FunNameStack::instance(); cout<<"File is "<<"/home/ismirnov/s06/wcpplib/safetl/AbsArr.h"<<" , line number is "<<208<<'\n'; spexit_action(cout); };
    }
    el = (fqel > 0) ? (new T[fqel]) : (T*)NULL;

    assignAll(val);
  }
  DynLinArr(long fqel, const T* ar, ArgInterp_Arr t):
    qel(fqel),

    el( NULL )
  {
    if(qel > max_qel_DynLinArr)
    {
      cout<<"ERROR in DynLinArr(long fqel, const T* ar, ArgInterp_Arr):\n";
      cout<<"qel > max_qel_DynLinArr:\n";
      cout<<indn<<"qel"<<"="<<noindent<<qel<<", "<<"max_qel_DynLinArr"<<"="<<noindent<<max_qel_DynLinArr<<'\n'<<yesindent;;
      cout<<"Type of T is (in internal notations) "<<typeid(T).name()<<'\n';
      {cout<<FunNameStack::instance(); cout<<"File is "<<"/home/ismirnov/s06/wcpplib/safetl/AbsArr.h"<<" , line number is "<<233<<'\n'; spexit_action(cout); };
    }
    if(qel < 0)
    {
      cout<<"ERROR in DynLinArr(long fqel, const T* ar, ArgInterp_Arr):\n";
      cout<<"qel < 0:\n";
      cout<<indn<<"qel"<<"="<<noindent<<qel<<'\n'<<yesindent;;
      cout<<"Type of T is (in internal notations) "<<typeid(T).name()<<'\n';
      {cout<<FunNameStack::instance(); cout<<"File is "<<"/home/ismirnov/s06/wcpplib/safetl/AbsArr.h"<<" , line number is "<<241<<'\n'; spexit_action(cout); };
    }
    el = (fqel > 0) ? (new T[fqel]) : (T*)NULL;

    long n; for( n=0; n<qel; n++) el[n]=ar[n];
  }
  DynLinArr<T>& operator=(const DynLinArr<T>& f);
  template<class D> DynLinArr<T>& operator=(const DynLinArr<D>& f);

  void pass(long fqel, T* fel)

  { clear(); qel = fqel; el = fel; }


  DynLinArr(const DynLinArr<T>& f):



    qel(0), el(NULL)
  {



    *this=f;
  }
  DynLinArr(const DynLinArr<T>& f, Pilfer):qel(f.qel), el(f.el)
  {



    f.qel = 0; f.el = 0;
  }
  DynLinArr(const DynArr<T>& f);


  DynLinArr(const DynArr<T>& f, int n_of_dim,

     long roc_number);


  DynLinArr& assignAll(const T& f)
    { check(); long n; for( n=0; n<qel; n++) el[n]=f; return *this; }
  template<class X> DynLinArr<T>& assignAll1(const X& f)


    { check(); long n; for( n=0; n<qel; n++) el[n].assignAll(f); return *this;}

  inline T& operator[](long n)
  {

    if( n>= 0 && n < qel)
    {
      return el[n];
    }
    else
    {
      cout<<"ERROR in const T& DynLinArr::operator[](long n) const: "
    <<"n is out of bounds, n="<<n
    <<" qel="<<qel<<'\n';
      cout<<"Type of T is (in internal notations) "<<typeid(T).name()<<'\n';
      {cout<<FunNameStack::instance(); cout<<"File is "<<"/home/ismirnov/s06/wcpplib/safetl/AbsArr.h"<<" , line number is "<<321<<'\n'; spexit_action(cout); };




 }
  }
  inline const T& operator[](long n) const
  {

    if( n>= 0 && n < qel)
    {
      return el[n];
    }
    else
    {
      cout<<"ERROR in const T& DynLinArr::operator[](long n) const: "
    <<"n is out of bounds, n="<<n
    <<" qel="<<qel<<'\n';
      cout<<"Type of T is (in internal notations) "<<typeid(T).name()<<'\n';
      {cout<<FunNameStack::instance(); cout<<"File is "<<"/home/ismirnov/s06/wcpplib/safetl/AbsArr.h"<<" , line number is "<<357<<'\n'; spexit_action(cout); };




 }
  }
  inline T& acu(long n)
  {
    return el[n];
  }
  inline const T& acu(long n) const
  {
    return el[n];
  }
  inline T& last_el(void)
  {

    if( qel > 0 )
    {
      return el[qel-1];
    }
    else
    {
      cout<<"ERROR in const T& DynLinArr::last_el(void) const: qel <=0:"
    <<" qel"<<qel<<'\n';
      cout<<"Type of T is (in internal notations) "<<typeid(T).name()<<'\n';
      {cout<<FunNameStack::instance(); cout<<"File is "<<"/home/ismirnov/s06/wcpplib/safetl/AbsArr.h"<<" , line number is "<<400<<'\n'; spexit_action(cout); };




    }



  }

  inline const T& last_el(void) const
  {

    if( qel > 0 )
    {
      return el[qel-1];
    }
    else
    {
      cout<<"ERROR in const T& DynLinArr::last_el(void) const: qel <=0:"
    <<" qel"<<qel<<'\n';
      cout<<"Type of T is (in internal notations) "<<typeid(T).name()<<'\n';
      {cout<<FunNameStack::instance(); cout<<"File is "<<"/home/ismirnov/s06/wcpplib/safetl/AbsArr.h"<<" , line number is "<<423<<'\n'; spexit_action(cout); };




    }



  }


  long get_qel(void) const { return qel; }
  void put_qel(long fqel);
  void put_qel(long fqel, const T* val, ArgInterp_SingleAdr t);
  void put_qel(long fqel, const T& val)
  {put_qel(fqel, &val, ArgInterp_SingleAdr());}
  void increment(const T* val=NULL)
    { check(); long q=qel+1; put_qel(q, *val); }
  void increment(const T& val)
    { check(); long q=qel+1; put_qel(q, val); }
  void clear(void) { put_qel(0); }

  void pilfer(const DynLinArr<T>& f)
  {



    if(this != &f)
    {
      if(qel != 0)
      {
 if(f.qel != 0)
 {
   cout<<"ERROR in DynLinArr::pilfer(...):\n";
   cout<<"Both the destination and source arrays are not empty\n";


   {cout<<FunNameStack::instance(); cout<<"File is "<<"/home/ismirnov/s06/wcpplib/safetl/AbsArr.h"<<" , line number is "<<475<<'\n'; spexit_action(cout); };
 }
 else
 {







   delete[] el;

   qel = 0;
 }
      }
      el = f.el; qel = f.qel;
      f.el = NULL; f.qel = 0;
    }
  }

  void check(void) const;
  DynArr<T> top(void);





  template<class P> friend void apply1(DynLinArr<P>& ar, void (*fun)(P& f));





  template<class P, class X> friend void apply2(DynLinArr<P>& ar,
   void (*fun1)(P& f, void (*fun21)(X& f) ),
   void (*fun2)(X& f) );
  void sort(long q_to_sort = 0);


  void sort(DynLinArr< long >& sort_ind, long q_to_sort = 0) const;
  virtual ~DynLinArr()
  { check();
  if(el != NULL)
    delete[] el;

  }
private:
  mutable long qel;
  mutable T* el;




};

template<class T>
void apply1(DynLinArr<T>& ar, void (*fun)(T& f))
{ long n; for(n=0; n<ar.qel; n++) (*fun)(ar.el[n]); }





template<class T, class X>
void apply2(DynLinArr<T>& ar,
     void (*fun1)(T& f, void (*fun21)(X& f) ),
     void (*fun2)(X& f) )
{ long n; for(n=0; n<ar.qel; n++) (*fun1)(ar.el[n], fun2); }
template<class T>
void DynLinArr<T>::check(void) const
{
  if(qel < 0)
  {
    cout<<"ERROR in template<class T> void DynLinArr<T>::check(void):\n";
    cout<<"qel < 0, qel="<<qel<<'\n';
    cout<<"Type of T is (in internal notations) "<<typeid(T).name()<<'\n';
    {cout<<FunNameStack::instance(); cout<<"File is "<<"/home/ismirnov/s06/wcpplib/safetl/AbsArr.h"<<" , line number is "<<619<<'\n'; spexit_action(cout); };
  }
  if(qel == 0 && el != NULL)
  {
    cout<<"ERROR in template<class T> void DynLinArr<T>::check(void):\n";

    cout<<"qel == 0 && el != NULL: el="<<el<<'\n';
    cout<<"Type of T is (in internal notations) "<<typeid(T).name()<<'\n';
    {cout<<FunNameStack::instance(); cout<<"File is "<<"/home/ismirnov/s06/wcpplib/safetl/AbsArr.h"<<" , line number is "<<627<<'\n'; spexit_action(cout); };
  }
  if(qel > 0)
  {
    if(el == NULL)
    {
      cout<<"ERROR in template<class T> void DynLinArr<T>::check(void):\n";
      cout<<"qel > 0 && el == NULL: qel="<<qel<<'\n';
      cout<<"Type of T is (in internal notations) "<<typeid(T).name()<<'\n';
      {cout<<FunNameStack::instance(); cout<<"File is "<<"/home/ismirnov/s06/wcpplib/safetl/AbsArr.h"<<" , line number is "<<636<<'\n'; spexit_action(cout); };
    }
    if(qel > max_qel_DynLinArr)
    {
      cout<<"ERROR in template<class T> void DynLinArr<T>::check(void):\n";
      cout<<"qel > max_qel_DynLinArr: \n";
      cout<<indn<<"qel"<<"="<<noindent<<qel<<", "<<"max_qel_DynLinArr"<<"="<<noindent<<max_qel_DynLinArr<<'\n'<<yesindent;;
      cout<<"Type of T is (in internal notations) "<<typeid(T).name()<<'\n';
      {cout<<FunNameStack::instance(); cout<<"File is "<<"/home/ismirnov/s06/wcpplib/safetl/AbsArr.h"<<" , line number is "<<644<<'\n'; spexit_action(cout); };
    }
  }
}

template<class T>
DynLinArr<T>& DynLinArr<T>::operator=(const DynLinArr<T>& f)
{



  if(this != &f)
  {


    check();
    f.check();



    long q = f.get_qel();
    T* temp_el = (T*)NULL;
    if(q > 0)
    {

      temp_el = new T[q];
      long n; for( n=0; n<q; n++) temp_el[n]=f.el[n];
    }
    pass(q, temp_el);


  }
  return *this;
}

template<class T> template<class D>
DynLinArr<T>& DynLinArr<T>::operator=(const DynLinArr<D>& f)
{







    check();
    f.check();



    long q = f.get_qel();
    T* temp_el = (T*)NULL;
    if(q > 0)
    {

      temp_el = new T[q];
      long n; for( n=0; n<q; n++) temp_el[n]=f.el[n];
    }



    pass(q, temp_el);



  return *this;
}

template<class T>
void DynLinArr<T>::put_qel(long fqel)







{
  long n;

  if(fqel < 0)
  {
    cout<<"ERROR in template<class T> void DynLinArr<T>::put_qel(long fqel):\n";
    cout<<"fqel < 0, fqel="<<fqel<<'\n';
    cout<<"Type of T is (in internal notations) "<<typeid(T).name()<<'\n';
    {cout<<FunNameStack::instance(); cout<<"File is "<<"/home/ismirnov/s06/wcpplib/safetl/AbsArr.h"<<" , line number is "<<770<<'\n'; spexit_action(cout); };
  }
  check();
  if(el==NULL)
  {
    qel=fqel;
    if(qel>0)






      el=new T[fqel];

  }
  else
  {
    if(qel != fqel)
    {
      if(fqel <= 0)
      {
 qel=0;




 delete[] el;

 el=NULL;
      }
      else
      {
 T* elh;




 elh=new T[fqel];

 for( n=0; n<fqel; n++)
 {
   if(n<qel) elh[n]=el[n];
 }




 delete[] el;

 el=elh; qel = fqel;
      }
    }
  }
}


template<class T>
void DynLinArr<T>::put_qel(long fqel, const T* val, ArgInterp_SingleAdr t)







{
  long n;

  if(fqel < 0)
  {
    cout<<"ERROR in template<class T> void DynLinArr<T>::put_qel(long fqel, const T* val, ArgInterp_SingleAdr):\n";
    cout<<"fqel < 0, fqel="<<fqel<<'\n';
    cout<<"Type of T is (in internal notations) "<<typeid(T).name()<<'\n';
    {cout<<FunNameStack::instance(); cout<<"File is "<<"/home/ismirnov/s06/wcpplib/safetl/AbsArr.h"<<" , line number is "<<844<<'\n'; spexit_action(cout); };
  }
  check();
  if(el==NULL)
  {
    qel=fqel;
    if(qel>0)






    el=new T[fqel];

    if(val != NULL) for( n=0; n<qel; n++) el[n]=*val;
  }
  else
  {
    if(qel != fqel)
    {
      if(fqel <= 0)
      {
 qel=0;




 delete[] el;

 el=NULL;
      }
      else
      {
 T* elh;




 elh=new T[fqel];

 for( n=0; n<fqel; n++)
 {
   if(n<qel) elh[n]=el[n];
   else if(val != NULL) elh[n]=*val;
 }




 delete[] el;

 el=elh; qel = fqel;
      }
    }
  }
}
template<class T>
void DynLinArr<T>::sort(long q_to_sort)
{
  static const char* FunNameIIII="void DynLinArr<T>::sort(long q_to_sort = 0)"; FunNameWatch funnw(FunNameIIII);

  if(q_to_sort > qel) { cout<<"ERROR:\n"; cout<<'\n'<<"q_to_sort"<<">"<<"qel"<<'\n'; cout<<"q_to_sort"<<'='<<(q_to_sort)<<' '<<"qel"<<'='<<(qel)<<'\n'; {cout<<FunNameStack::instance(); cout<<"File is "<<"/home/ismirnov/s06/wcpplib/safetl/AbsArr.h"<<" , line number is "<<914<<'\n'; spexit_action(cout); }; };
  if(q_to_sort <= 0) q_to_sort = qel;
  if(q_to_sort <= 1) return;

  long n_possible_next = 1;
  long q_comp = 0;
  long n,m;
  for(n=0; n<q_to_sort-1; n++)
  {


    long nmin = n_possible_next;
    T el_min = el[nmin];
    int s_change_possible_next = 0;


    for(m=n_possible_next+1; m<q_to_sort; m++)
    {
      q_comp++;

      if(el_min > el[m])
      {
 n_possible_next = nmin;
 s_change_possible_next = 1;
 nmin = m;
 el_min = el[nmin];
      }
    }
    if(s_change_possible_next == 0 || n_possible_next < n+2)
    {
      n_possible_next = n+2;
    }






    if(el[n] > el_min)
    {
      if(s_change_possible_next == 1)
      {
 if(n_possible_next < q_to_sort)


 {
   n_possible_next = nmin;
 }
      }
      T t = el_min;
      el_min = el[n];
      el[n] = t;
    }

  }
  cout<<indn<<"q_comp"<<"="<<noindent<<q_comp<<'\n'<<yesindent;;
}



template<class T>
void DynLinArr<T>::sort(DynLinArr< long >& sort_ind, long q_to_sort) const
{
  static const char* FunNameIIII="void DynLinArr<T>::sort(DynLinArr< long >& sort_ind, long q_to_sort = 0) const"; FunNameWatch funnw(FunNameIIII);

  if(q_to_sort > qel) { cout<<"ERROR:\n"; cout<<'\n'<<"q_to_sort"<<">"<<"qel"<<'\n'; cout<<"q_to_sort"<<'='<<(q_to_sort)<<' '<<"qel"<<'='<<(qel)<<'\n'; {cout<<FunNameStack::instance(); cout<<"File is "<<"/home/ismirnov/s06/wcpplib/safetl/AbsArr.h"<<" , line number is "<<979<<'\n'; spexit_action(cout); }; };
  if(q_to_sort <= 0) q_to_sort = qel;
  if(q_to_sort <= 1) return;


  sort_ind.clear();
  sort_ind.pilfer(DynLinArr< long >(q_to_sort));
  long n,m;
  for(n=0; n<q_to_sort; n++)
  {
    sort_ind.acu(n) = n;
  }

  long n_possible_next = 1;

  for(n=0; n<q_to_sort-1; n++)
  {

    long nmin = n_possible_next;
    long ind_nmin = sort_ind.acu(nmin);
    int s_change_possible_next = 0;


    for(m=n_possible_next+1; m<q_to_sort; m++)
    {
      if(el[ind_nmin] > el[sort_ind.acu(m)])

      {
 n_possible_next = nmin;
 s_change_possible_next = 1;
 nmin = m;
 ind_nmin = sort_ind.acu(nmin);
      }
    }
    if(s_change_possible_next == 0 || n_possible_next < n+2)
    {
      n_possible_next = n+2;
    }
    if(el[sort_ind.acu(n)] > el[ind_nmin])

    {
      if(s_change_possible_next == 1)
      {
 if(n_possible_next < q_to_sort &&
    el[sort_ind.acu(n)] < el[sort_ind.acu(n_possible_next)])
 {
   n_possible_next = nmin;
 }
      }

      sort_ind.acu(nmin) = sort_ind.acu(n);
      sort_ind.acu(n) = ind_nmin;
    }
  }
}
template<class T>
long append(const T& t,
     DynLinArr<T>& dla,

     long& qael,




     T* tempt=NULL,
     long new_qel=0
     )
{
  if(dla.get_qel() < qael)
  {
    cout<<"ERROR in long append(class DynLinArr& dla, ...): dla.get_qel() < qael\n"
  <<"dla.get_qel()="<<dla.get_qel()<<" qael="<<qael<<'\n';
    cout<<"Type of T is (in internal notations) "<<typeid(T).name()<<'\n';
    {cout<<FunNameStack::instance(); cout<<"File is "<<"/home/ismirnov/s06/wcpplib/safetl/AbsArr.h"<<" , line number is "<<1132<<'\n'; spexit_action(cout); };
  }
  if(dla.get_qel() == qael)
  {
    if(new_qel<=qael) new_qel=find_max(3*qael, long(3));
    dla.put_qel(new_qel, tempt, ArgInterp_SingleAdr());
  }
  dla[qael++] = t;
  return qael;
}
template<class T>
ostream& operator<<(ostream& file, const DynLinArr<T>& f)
{


  file<<indn<<"DynLinArr<T>: qel="<<f.get_qel()<<'\n';
  f.check();
  long n;
  indn.n+=2;
  for( n=0; n<f.get_qel(); n++)
  {

    if(s_short_output == 0)
    {
      file<<indn<<"n="<<n<<" el[n]=";
    }
    std::ostringstream ost;
    ost<<indn<<noindent<<f[n]<<yesindent;
    put_one_n(ost);
    file<<ost.str();
  }

  indn.n-=2;
  return file;
}
int definp_int(const String& str = String());
long definp_long(const String& str = String());
double definp_double(const String& str = String());
String definp_String(const String& str = String());





long set_position(const String& word, std::istream& istrm,
    int s_rewind, int s_req_sep);





class definp_endpar
{public:
  std::istream* istrm;



  int s_rewind;
  int s_req_sep;
  int s_print;
  int s_short;

  definp_endpar(void): istrm(NULL), s_rewind(0), s_req_sep(0), s_print(0),
         s_short(0) {;}
  definp_endpar(std::istream* fistrm, int fs_rewind, int fs_req_sep,
  int fs_print=1, int fs_short = 0 ):
  istrm(fistrm), s_rewind(fs_rewind), s_req_sep(fs_req_sep), s_print(fs_print),
  s_short(fs_short) {;}
};





template< class T > void definp_any_par
 (T& inp, const String& word, const definp_endpar& dep,
  int fs_short = 0)
{
  static const char* FunNameIIII="template< class T > definp_any_par(...)"; FunNameWatch funnw(FunNameIIII);
  if(dep.istrm->good() != 1) { cout<<"ERROR:\n"; cout<<'\n'<<"dep.istrm->good()"<<"!= 1"<<'\n'; cout<<"dep.istrm->good()"<<'='<<(dep.istrm->good())<<'\n'; cout<<"before input of variable named "<<word<<'\n'; {cout<<FunNameStack::instance(); cout<<"File is "<<"/home/ismirnov/s06/wcpplib/stream/definp.h"<<" , line number is "<<65<<'\n'; spexit_action(cout); }; };




  if(fs_short == 0)
    if(dep.s_short == 0)
      set_position(word, *dep.istrm, dep.s_rewind, dep.s_req_sep);
  (*(dep.istrm)) >> inp;
  if(dep.s_print == 1)

    cout<<indn<<"definp_any_par: "<<word<<' '<<inp<<'\n';

  if(dep.istrm->good() != 1) { cout<<"ERROR:\n"; cout<<'\n'<<"dep.istrm->good()"<<"!= 1"<<'\n'; cout<<"dep.istrm->good()"<<'='<<(dep.istrm->good())<<'\n'; cout<<"after input of variable named "<<word<<"\nwhose input value is "<<inp<<'\n'; {cout<<FunNameStack::instance(); cout<<"File is "<<"/home/ismirnov/s06/wcpplib/stream/definp.h"<<" , line number is "<<77<<'\n'; spexit_action(cout); }; };

}
template< class T > void definp_any_2par
 (T& inp1, T& inp2, const String& word, const definp_endpar& dep,
  int fs_short = 0 )
{
  static const char* FunNameIIII="template< class T > definp_any_par(...)"; FunNameWatch funnw(FunNameIIII);
  if(fs_short == 0)
    if(dep.s_short == 0)
      set_position(word, *dep.istrm, dep.s_rewind, dep.s_req_sep);
  (*(dep.istrm)) >> inp1 >> inp2;
  if(dep.s_print == 1)
    cout<<indn<<"definp_any_par: "<<word<<' '<<inp1<<' '<<inp2<<'\n';

  if(dep.istrm->good() != 1) { cout<<"ERROR:\n"; cout<<'\n'<<"dep.istrm->good()"<<"!= 1"<<'\n'; cout<<"dep.istrm->good()"<<'='<<(dep.istrm->good())<<'\n'; cout<<"after input of variables after word "<<word<<"\nwhose input values are "<<inp1<<' '<<inp2<<'\n'; {cout<<FunNameStack::instance(); cout<<"File is "<<"/home/ismirnov/s06/wcpplib/stream/definp.h"<<" , line number is "<<101<<'\n'; spexit_action(cout); }; };

}
void remove_end_comments(std::istream& istr, String commark,
       DynLinArr< char >& istring);
template<class T>
istream& operator>>(istream& file, DynLinArr<T>& f)
{
  static const char* FunNameIIII="template<class T> istream& operator>>(istream& file, DynLinArr<T>& f)"; FunNameWatch funnw(FunNameIIII);

  definp_endpar dep(&file, 0, 1, 0, s_short_output);
  long qel=0;
  dep.s_short = 0;
  definp_any_par(qel, String("qel""="), dep );
  dep.s_short = s_short_output;
  if(qel < 0) { cout<<"ERROR:\n"; cout<<'\n'<<"qel"<<"< 0"<<'\n'; cout<<"qel"<<'='<<(qel)<<'\n'; {cout<<FunNameStack::instance(); cout<<"File is "<<"/home/ismirnov/s06/wcpplib/safetl/AbsArr.h"<<" , line number is "<<1230<<'\n'; spexit_action(cout); }; };
  f.clear();
  f.put_qel(qel);
  long fn;
  for( fn=0; fn<qel; fn++)
  {
    if(s_short_output == 0)
    {
      long n=0;
      definp_any_par(n, String("n""="), dep );
      if(fn != n) { cout<<"ERROR:\n"; cout<<'\n'<<"fn"<<"!="<<"n"<<'\n'; cout<<"fn"<<'='<<(fn)<<' '<<"n"<<'='<<(n)<<'\n'; {cout<<FunNameStack::instance(); cout<<"File is "<<"/home/ismirnov/s06/wcpplib/safetl/AbsArr.h"<<" , line number is "<<1240<<'\n'; spexit_action(cout); }; };
    }


    definp_any_par(f[fn], "el[n]=", dep);
  }
  return file;
}

template<class T>
void output_DynLinArr(ostream& file, const DynLinArr<T>& f, int l, long q)
{

  file<<indn<<"DynLinArr<T>: qel="<<f.get_qel()<<" q to print is "<<q<<'\n';
  f.check();
  if(q>f.get_qel())
  {
    cout<<"output_DynLinArr(...): q>f.get_qel(), q="<<q
  <<" f.get_qel()="<<f.get_qel()<<'\n';
    cout<<"Type of T is (in internal notations) "<<typeid(T).name()<<'\n';
    {cout<<FunNameStack::instance(); cout<<"File is "<<"/home/ismirnov/s06/wcpplib/safetl/AbsArr.h"<<" , line number is "<<1260<<'\n'; spexit_action(cout); };
  }
  long n;
  indn.n+=2;
  for( n=0; n<q; n++)
  {

    file<<indn<<"n="<<n<<" el[n]="<<noindent;
    std::ostringstream ost;
    ost<<f[n]<<yesindent;
    put_one_n(ost);
    file<<ost.str();
  }

  indn.n-=2;
}


template<class T>
void print_DynLinArr(ostream& file, const DynLinArr<T>& f, int l)
{

  file<<indn<<"DynLinArr<T>: qel="<<f.get_qel()<<'\n';
  f.check();
  long n;
  indn.n+=2;
  for( n=0; n<f.get_qel(); n++)
  {


    file<<indn<<"n="<<n<<" el[n]="<<noindent;
    std::ostringstream ost;
    f[n].print(ost, l);
    ost<<yesindent;
    put_one_n(ost);
    file<<ost.str();
  }
  indn.n-=2;
}
template<class T>
void print_DynLinArr(ostream& file, const DynLinArr<T>& f, int l, long q)
{

  file<<indn<<"DynLinArr<T>: qel="<<f.get_qel()<<" q to print is "<<q<<'\n';
  f.check();
  if(q>f.get_qel())
  {
    cout<<"print_DynLinArr(...): q>f.get_qel(), q="<<q
  <<" f.get_qel()="<<f.get_qel()<<'\n';
    cout<<"Type of T is (in internal notations) "<<typeid(T).name()<<'\n';
    {cout<<FunNameStack::instance(); cout<<"File is "<<"/home/ismirnov/s06/wcpplib/safetl/AbsArr.h"<<" , line number is "<<1329<<'\n'; spexit_action(cout); };
  }
  long n;
  indn.n+=2;
  for( n=0; n<q; n++)
  {


    file<<indn<<"n="<<n<<" el[n]="<<noindent;
    std::ostringstream ost;
    f[n].print(ost, l);
    ost<<yesindent;
    put_one_n(ost);
    file<<ost.str();
  }
  indn.n-=2;
}

template<class T>
void print_adr_DynLinArr(ostream& file, const DynLinArr<T>& f, int l, long q)
{

  file<<indn<<"DynLinArr<T>: qel="<<f.get_qel()<<" q to print is "<<q<<'\n';
  f.check();
  if(q>f.get_qel())
  {
    cout<<"print_adr_DynLinArr(...): q>f.get_qel(), q="<<q
  <<" f.get_qel()="<<f.get_qel()<<'\n';
    cout<<"Type of T is (in internal notations) "<<typeid(T).name()<<'\n';
    {cout<<FunNameStack::instance(); cout<<"File is "<<"/home/ismirnov/s06/wcpplib/safetl/AbsArr.h"<<" , line number is "<<1358<<'\n'; spexit_action(cout); };
  }
  long n;
  indn.n+=2;
  for( n=0; n<q; n++)
  {


    file<<indn<<"n="<<n<<" el[n]="<<noindent;
    std::ostringstream ost;
    f[n]->print(ost, l);
    ost<<yesindent;
    put_one_n(ost);
    file<<ost.str();
  }
  indn.n-=2;
}

const int pq_arrelem_in_line=5;

void print_DynLinArr_int(ostream& file, const DynLinArr<int>& f);
void print_DynLinArr_long(ostream& file, const DynLinArr<long>& f);
void print_DynLinArr_float(ostream& file, const DynLinArr<float>& f);
void print_DynLinArr_double(ostream& file, const DynLinArr<double>& f);


void print_DynLinArr_double2(ostream& file,
        const DynLinArr<double>& f1,
        const DynLinArr<double>& f2);



void print_DynLinArr_int_double(ostream& file,
     const DynLinArr<int>& iar,
     const DynLinArr<double>& dar);

void print_DynLinArr_int_double3(ostream& file,
     const DynLinArr<int>& iar,
     const DynLinArr<double>& dar1,
     const DynLinArr<double>& dar2,
     const DynLinArr<double>& dar3);
template<class T, class X>
void copy_DynLinArr(const T& s, X& d)
{
  static const char* FunNameIIII="template<class T, class X> void copy_DynLinArr(const T& s, X& d)"; FunNameWatch funnw(FunNameIIII);
  s.check(); d.check();
  long q=s.get_qel();
  d.put_qel(q);
  long n;
  for( n=0; n<q; n++)
  {
    d[n]=s[n];
  }
}


template<class T, class X>
void convert_DynLinArr(const T& s, X& d)
{
  long q=s.get_qel();
  d.put_qel(q);
  long n;
  for( n=0; n<q; n++)
  {
    d[n]=X(s[n]);
  }
}

template<class T>
void put_qel_1(DynLinArr<T>& f, long fq)

{
  long q=f.get_qel();
  long n;
  for( n=0; n<q; n++) f[n].put_qel(fq);
}

template<class T, class T1 >
void assignAll_1(DynLinArr<T>& f, const T1& ft)

{
  long q=f.get_qel();
  long n;
  for( n=0; n<q; n++) f[n].assignAll(ft);
}


template<class T> class IterDynLinArr
{public:
  IterDynLinArr(DynLinArr<T>* fdar): dar(fdar), ncur(-1) {;}
  T* more(void)
    {if(ncur < dar->get_qel()-1) return &((*dar)[++ncur]);
    else ncur = dar->get_qel(); return NULL;}
  T* current(void)
    {if(ncur >= 0 || ncur < dar->get_qel()) return &((*dar)[ncur]);
    else return NULL;}
  T* less(void)
    {if(ncur >= 1 ) return &((*dar)[--ncur]);
    else ncur = -1; return NULL;}
  long get_ncur(void) { return ncur; }
private:
  long ncur;
  DynLinArr<T>* dar;
};

int gconfirm_ind(const DynLinArr<long>& qel, const DynLinArr<long>& ind);
int gconfirm_ind_ext(const DynLinArr<long>& qel, const DynLinArr<long>& ind);
template<class T>
int ifequal(const DynLinArr<T>& fd1, const DynLinArr<T>& fd2,
   long qfirst=-1)
{
  long n;
  if(qfirst==-1)
  {
    if((qfirst=fd1.get_qel()) != fd2.get_qel()) return 0;

  }
  else
  {
    if(qfirst > fd1.get_qel() || qfirst > fd2.get_qel()) return 0;
  }

  for( n=0; n<qfirst; n++)
  {

    if( !(fd1[n] == fd2[n]) ) return 0;
  }
  return 1;
}


template<class T>
int ifequal(const DynLinArr<T>& fd1, const T* fd2,
   long qfirst=-1)
{
  long n;
  if(qfirst==-1)
  {
    qfirst=fd1.get_qel();
  }
  else
  {
    if(qfirst > fd1.get_qel() ) return 0;
  }
  for( n=0; n<qfirst; n++)
    if( !(fd1[n] == fd2[n]) ) return 0;
  return 1;
}

template<class T>
int ifequal(T* fd1, T* fd2,
   long qfirst)
{
  long n;
  for( n=0; n<qfirst; n++)
    if( !(fd1[n] == fd2[n]) ) return 0;
  return 1;
}

template<class T>
DynLinArr<T> merge(const DynLinArr<T>& fd1, long qfd1,
     const DynLinArr<T>& fd2, long qfd2)
{
  long n;
  if(qfd1 < 0)
  {
    qfd1 = fd1.get_qel();
  }
  if(qfd2 < 0)
  {
    qfd2 = fd2.get_qel();
  }
  DynLinArr<T> ret(qfd1 + qfd2);
  if(qfd1 + qfd2 == 0) return ret;
  for(n=0; n<qfd1; n++)
  {
    ret[n] = fd1[n];
  }
  for(n=0; n<qfd2; n++)
  {
    ret[qfd1 + n] = fd2[n];
  }
  return ret;
}







template<class T>class DynArr

{public:
  DynArr(void) {;}


  explicit DynArr(long fqel, T* val=NULL): qel(DynLinArr<long>(1)),
    cum_qel(DynLinArr<long>(1)),
    el(DynLinArr<T>(fqel))
    {



      qel[0]=fqel; cum_qel[0]=1; if(val!=NULL) assignAll(*val);
    }

  DynArr(long fqel, T val, ArgInterp_Val t): qel(DynLinArr<long>(1)),
    cum_qel(DynLinArr<long>(1)),
    el(DynLinArr<T>(fqel))
    {



      qel[0]=fqel; cum_qel[0]=1; assignAll(val);
    }

  DynArr(long fqel, const T* ar, ArgInterp_Arr t): qel(DynLinArr<long>(1)),
    cum_qel(DynLinArr<long>(1)),
    el(fqel)

    { qel[0]=fqel; cum_qel[0]=1;
      long n; for( n=0; n<fqel; n++) el.acu(n)=ar[n];
    }




  DynArr(const DynLinArr<T>& f): qel(DynLinArr<long>(1)),
    cum_qel(DynLinArr<long>(1)),
    el(f.get_qel())

    { qel[0]=f.get_qel(); cum_qel[0]=1;
    for( long n=0; n<qel[0]; n++ ) ac(n) = f[n]; }



  DynArr(long fqel1, long fqel2, T* val=NULL):
    qel(DynLinArr<long>(2)), cum_qel(DynLinArr<long>(2)),
    el(fqel1*fqel2)

    {



      qel[0]=fqel1; qel[1]=fqel2; cum_qel[0]=fqel2; cum_qel[1]=1;
      if(val!=NULL) assignAll(*val);
    }

  DynArr(long fqel1, long fqel2, T val, ArgInterp_Val t):
    qel(DynLinArr<long>(2)), cum_qel(DynLinArr<long>(2)),
    el(fqel1*fqel2)

    {



      qel[0]=fqel1; qel[1]=fqel2; cum_qel[0]=fqel2; cum_qel[1]=1;
      assignAll(val);
    }


  DynArr(long fqel1, long fqel2, long fqel3, T* val=NULL):
    qel(DynLinArr<long>(3)), cum_qel(DynLinArr<long>(3)),
    el(fqel1*fqel2*fqel3)

    { qel[0]=fqel1; qel[1]=fqel2; qel[2]=fqel3;
    cum_qel[0]=fqel2*fqel3; cum_qel[1]=fqel3; cum_qel[2]=1;
    if(val!=NULL) assignAll(*val);}


  DynArr(long fqel1, long fqel2, long fqel3, long fqel4, T* val=NULL):
    qel(DynLinArr<long>(4)), cum_qel(DynLinArr<long>(4)),
    el(fqel1*fqel2*fqel3*fqel4)

    { qel[0]=fqel1; qel[1]=fqel2; qel[2]=fqel3; qel[3]=fqel4;
    cum_qel[0]=fqel2*fqel3*fqel4; cum_qel[1]=fqel3*fqel4;
    cum_qel[2]=fqel4; cum_qel[3]=1; if(val!=NULL) assignAll(*val); }
  DynArr(const DynLinArr<long>& fqel, T val, ArgInterp_Val t):
    qel(fqel)
    {
      long qdim=qel.get_qel();
      if(qdim<=0) return;
      cum_qel.put_qel(qdim);
      long ndim;
      long size=qel[0];
      for( ndim=1; ndim<qdim; ndim++) size *= qel[ndim];
      el.put_qel(size);
      cum_qel[qdim-1]=1;
      for( ndim=qdim-2; ndim>=0; ndim--)
 cum_qel[ndim] = qel[ndim+1] * cum_qel[ndim+1];
      assignAll(val);
    }

  explicit DynArr(const DynLinArr<long>& fqel,
    T* val):

    qel(fqel)
    {
      long qdim=qel.get_qel();
      if(qdim<=0) return;
      cum_qel.put_qel(qdim);
      long ndim;
      long size=qel[0];
      for( ndim=1; ndim<qdim; ndim++) size *= qel[ndim];
      el.put_qel(size);
      cum_qel[qdim-1]=1;
      for( ndim=qdim-2; ndim>=0; ndim--)
 cum_qel[ndim] = qel[ndim+1] * cum_qel[ndim+1];
       if(val!=NULL) assignAll(*val);
    }

  DynArr(const DynArr<T>& f)



  {



    *this = f;
  }
  DynArr(const DynArr<T>& f, Pilfer):qel(f.qel,steal),
    cum_qel(f.cum_qel,steal),
    el(f.el,steal)
  {



  }

  void pilfer(const DynArr<T>& f)
  {



    if(this != &f)
    {
      if(qel.get_qel() != 0)
      {
 if(f.qel.get_qel() != 0)
 {
   cout<<"ERROR in DynArr::pilfer(...):\n";
   cout<<"Both the destination and source arrays are not empty\n";


   {cout<<FunNameStack::instance(); cout<<"File is "<<"/home/ismirnov/s06/wcpplib/safetl/AbsArr.h"<<" , line number is "<<1741<<'\n'; spexit_action(cout); };
 }
 else { qel.clear(); cum_qel.clear(); el.clear(); }
      }
      qel.pilfer(f.qel); cum_qel.pilfer(f.cum_qel); el.pilfer(f.el);
      f.qel.clear(); f.cum_qel.clear(); f.el.clear();
    }
  }

  DynArr<T>& operator=(const DynArr<T>& f);
  template<class D> DynArr<T>& operator=(const DynArr<D>& f);

  void pass(long q, DynLinArr<long> fqel, DynLinArr<long> fcum_qel, T* fel)


  { clear(); qel = fqel; cum_qel = fcum_qel; el.pass(q, fel); }



  template<class D> class IndexingProvider
  {public:
    DynArr<D>& arr;
    mutable long q_deref_ind;
    mutable long current_pos;
    IndexingProvider(DynArr<D>& farr, long fq_deref_ind, long fcurrent_pos):
      arr(farr), q_deref_ind(fq_deref_ind), current_pos(fcurrent_pos) {}
    operator D& () const
    {
      if(q_deref_ind != arr.qel.get_qel())
      {
 cout<<"ERROR in IndexingProvider::operator D& (): q_deref_ind != qel.get_qel()\n";
 cout<<indn<<"q_deref_ind"<<"="<<noindent<<q_deref_ind<<", "<<"arr.qel.get_qel()"<<"="<<noindent<<arr.qel.get_qel()<<'\n'<<yesindent;;
 cout<<"Type of T is (in internal notations) "<<typeid(D).name()<<'\n';
 {cout<<FunNameStack::instance(); cout<<"File is "<<"/home/ismirnov/s06/wcpplib/safetl/AbsArr.h"<<" , line number is "<<1774<<'\n'; spexit_action(cout); };
      }

      return arr.el[current_pos];



    }
    D& operator=(const D& f)
    {
      if(q_deref_ind != arr.get_qel().get_qel())
      {
 cout<<"ERROR in T& IndexingProvider::operator=(T& f): q_deref_ind != arr.get_qel().get_qel()\n";
 cout<<indn<<"q_deref_ind"<<"="<<noindent<<q_deref_ind<<", "<<"arr.get_qel().get_qel()"<<"="<<noindent<<arr.get_qel().get_qel()<<'\n'<<yesindent;;
 cout<<"Type of T is (in internal notations) "<<typeid(D).name()<<'\n';
 {cout<<FunNameStack::instance(); cout<<"File is "<<"/home/ismirnov/s06/wcpplib/safetl/AbsArr.h"<<" , line number is "<<1789<<'\n'; spexit_action(cout); };
      }

      arr.ac_lin(current_pos) = f;




    }

    inline IndexingProvider<D>& operator[](long n)
    {
      if(q_deref_ind >= arr.get_qel().get_qel())
      {
 cout<<"ERROR in DynArr::IndexingProvider& DynArr::operator[](long n): q_deref_ind >= arr.get_qel().get_qel()\n";
 cout<<indn<<"q_deref_ind"<<"="<<noindent<<q_deref_ind<<", "<<"arr.get_qel().get_qel()"<<"="<<noindent<<arr.get_qel().get_qel()<<'\n'<<yesindent;;
 cout<<"Type of T is (in internal notations) "<<typeid(D).name()<<'\n';
 {cout<<FunNameStack::instance(); cout<<"File is "<<"/home/ismirnov/s06/wcpplib/safetl/AbsArr.h"<<" , line number is "<<1806<<'\n'; spexit_action(cout); };
      }

      if(n >= 0 && n < arr.qel.acu(q_deref_ind))
      {

 current_pos += n * arr.get_cum_qel().acu(q_deref_ind);
 q_deref_ind++;
 return *this;

      }
      else
      {
 cout<<"Error in IndexingProvider<D>& IndexingProvider::operator[](long n): n < 0 || n >= qel.acu(q_deref_ind)\n";
 cout<<indn<<"n"<<"="<<noindent<<n<<", "<<"arr.qel.acu(q_deref_ind)"<<"="<<noindent<<arr.qel.acu(q_deref_ind)<<'\n'<<yesindent;;
 cout<<"Type of T is (in internal notations) "<<typeid(T).name()<<'\n';
 {cout<<FunNameStack::instance(); cout<<"File is "<<"/home/ismirnov/s06/wcpplib/safetl/AbsArr.h"<<" , line number is "<<1822<<'\n'; spexit_action(cout); };
      }

    }

    inline const IndexingProvider<D>& operator[](long n) const
    {
      if(q_deref_ind >= arr.get_qel().get_qel())
      {
 cout<<"ERROR in DynArr::IndexingProvider& DynArr::operator[](long n): q_deref_ind >= arr.get_qel().get_qel()\n";
 cout<<indn<<"q_deref_ind"<<"="<<noindent<<q_deref_ind<<", "<<"arr.get_qel().get_qel()"<<"="<<noindent<<arr.get_qel().get_qel()<<'\n'<<yesindent;;
 cout<<"Type of T is (in internal notations) "<<typeid(D).name()<<'\n';
 {cout<<FunNameStack::instance(); cout<<"File is "<<"/home/ismirnov/s06/wcpplib/safetl/AbsArr.h"<<" , line number is "<<1834<<'\n'; spexit_action(cout); };
      }

      if(n >= 0 && n < arr.qel.acu(q_deref_ind))
      {

 current_pos += n * arr.get_cum_qel().acu(q_deref_ind);
 q_deref_ind++;
 return *this;

      }
      else
      {
 cout<<"Error in IndexingProvider<D>& IndexingProvider::operator[](long n): n < 0 || n >= qel.acu(q_deref_ind)\n";
 cout<<indn<<"n"<<"="<<noindent<<n<<", "<<"arr.qel.acu(q_deref_ind)"<<"="<<noindent<<arr.qel.acu(q_deref_ind)<<'\n'<<yesindent;;
 cout<<"Type of T is (in internal notations) "<<typeid(T).name()<<'\n';
 {cout<<FunNameStack::instance(); cout<<"File is "<<"/home/ismirnov/s06/wcpplib/safetl/AbsArr.h"<<" , line number is "<<1850<<'\n'; spexit_action(cout); };
      }

    }

  };





  inline IndexingProvider<T> operator[](long n)
  {
    if(qel.get_qel() < 1)
    {
      cout<<"ERROR in DynArr::IndexingProvider DynArr::operator[](long n): qel.get_qel()< 1, qel.get_qel()="
    <<qel.get_qel()<<'\n';
      cout<<"Type of T is (in internal notations) "<<typeid(T).name()<<'\n';
      {cout<<FunNameStack::instance(); cout<<"File is "<<"/home/ismirnov/s06/wcpplib/safetl/AbsArr.h"<<" , line number is "<<1868<<'\n'; spexit_action(cout); };
    }

    if(n >= 0 && n < qel.acu(0))
    {

      return IndexingProvider<T>(*this, 1, n*cum_qel.acu(0));

    }
    else
    {
      cout<<"Error in IndexingProvider<T> DynArr::operator[](long n): n < 0 || n >= qel.acu(0)\n";
      cout<<indn<<"n"<<"="<<noindent<<n<<", "<<"qel.acu(0)"<<"="<<noindent<<qel.acu(0)<<'\n'<<yesindent;;
      cout<<"Type of T is (in internal notations) "<<typeid(T).name()<<'\n';
      {cout<<FunNameStack::instance(); cout<<"File is "<<"/home/ismirnov/s06/wcpplib/safetl/AbsArr.h"<<" , line number is "<<1882<<'\n'; spexit_action(cout); };
    }

  }

  inline const IndexingProvider<T> operator[](long n) const
  {
    if(qel.get_qel() < 1)
    {
      cout<<"ERROR in DynArr::IndexingProvider DynArr::operator[](long n): qel.get_qel()< 1, qel.get_qel()="
    <<qel.get_qel()<<'\n';
      cout<<"Type of T is (in internal notations) "<<typeid(T).name()<<'\n';
      {cout<<FunNameStack::instance(); cout<<"File is "<<"/home/ismirnov/s06/wcpplib/safetl/AbsArr.h"<<" , line number is "<<1894<<'\n'; spexit_action(cout); };
    }

    if(n >= 0 && n < qel.acu(0))
    {


      DynArr<T>* temp = const_cast<DynArr<T>*>(this);

      return IndexingProvider<T>(*temp, 1, n*cum_qel.acu(0) );

    }
    else
    {
      cout<<"Error in IndexingProvider<T> DynArr::operator[](long n): n < 0 || n >= qel.acu(0)\n";
      cout<<indn<<"n"<<"="<<noindent<<n<<", "<<"qel.acu(0)"<<"="<<noindent<<qel.acu(0)<<'\n'<<yesindent;;
      cout<<"Type of T is (in internal notations) "<<typeid(T).name()<<'\n';
      {cout<<FunNameStack::instance(); cout<<"File is "<<"/home/ismirnov/s06/wcpplib/safetl/AbsArr.h"<<" , line number is "<<1911<<'\n'; spexit_action(cout); };
    }

  }

  T& ac(long i)
    {
      if(qel.get_qel() == 1) return el[i];
      else
      {
 cout<<"ERROR in DynArr::ac(long i): qel.get_qel()!= 1, qel.get_qel()="
      <<qel.get_qel()<<'\n';
 cout<<"Type of T is (in internal notations) "<<typeid(T).name()<<'\n';
 {cout<<FunNameStack::instance(); cout<<"File is "<<"/home/ismirnov/s06/wcpplib/safetl/AbsArr.h"<<" , line number is "<<1924<<'\n'; spexit_action(cout); };




      }

    }
  const T& ac(long i) const
    {
      if(qel.get_qel() == 1) return el[i];
      else
      {
 cout<<"ERROR in DynArr::ac(long i): qel.get_qel()!= 1, qel.get_qel()="
      <<qel.get_qel()<<'\n';
 cout<<"Type of T is (in internal notations) "<<typeid(T).name()<<'\n';
 {cout<<FunNameStack::instance(); cout<<"File is "<<"/home/ismirnov/s06/wcpplib/safetl/AbsArr.h"<<" , line number is "<<1940<<'\n'; spexit_action(cout); };




      }
    }
  inline T& acu(long i1)
  {
    return el.acu(i1);
  }
  inline const T& acu(long i1) const
  {
    return el.acu(i1);
  }


  T& ac(const DynLinArr<long>& ind)



    {
      long q;
      if((q=qel.get_qel()) != ind.get_qel())
      { cout<<"ERROR in DynArr::ac(const DynLinArr<long>& ind): "
      <<"qel.get_qel()!= ind.get_qel()\n"
      <<"qel.get_qel()="<<qel.get_qel()
      <<" ind.get_qel()="<<ind.get_qel()
      <<'\n';
      cout<<"Type of T is (in internal notations) "<<typeid(T).name()<<'\n';
      {cout<<FunNameStack::instance(); cout<<"File is "<<"/home/ismirnov/s06/wcpplib/safetl/AbsArr.h"<<" , line number is "<<1978<<'\n'; spexit_action(cout); }; }







      if(q == 1)
 return el[ind.acu(0)];
      else
 return el.acu(calc_lin_ind(ind));







    }
  const T& ac(const DynLinArr<long>& ind) const
    {
      long q;
      if((q=qel.get_qel()) != ind.get_qel())
      { cout<<"ERROR in DynArr::ac(const DynLinArr<long>& ind): "
      <<"qel.get_qel()!= ind.get_qel()\n"
      <<"qel.get_qel()="<<qel.get_qel()
      <<" ind.get_qel()="<<ind.get_qel()
      <<'\n';
      cout<<"Type of T is (in internal notations) "<<typeid(T).name()<<'\n';
      {cout<<FunNameStack::instance(); cout<<"File is "<<"/home/ismirnov/s06/wcpplib/safetl/AbsArr.h"<<" , line number is "<<2008<<'\n'; spexit_action(cout); }; }
      if(q == 1)
 return el[ind.acu(0)];
      else
 return el.acu(calc_lin_ind(ind));







    }

  T& acp(const DynLinArr<long>& ind)


    {
      long q;
      if((q=qel.get_qel()) > ind.get_qel())
      { cout<<"ERROR in DynArr::acp(const DynLinArr<long>& ind): "
      <<"qel.get_qel()!= ind.get_qel()\n"
      <<"qel.get_qel()="<<qel.get_qel()
      <<" ind.get_qel()="<<ind.get_qel()
      <<'\n';
      cout<<"Type of T is (in internal notations) "<<typeid(T).name()<<'\n';
      {cout<<FunNameStack::instance(); cout<<"File is "<<"/home/ismirnov/s06/wcpplib/safetl/AbsArr.h"<<" , line number is "<<2054<<'\n'; spexit_action(cout); }; }
      if(q == 1)
 return el[ind.acu(0)];
      else
 return el.acu(calc_lin_ind(ind));







    }

  const T& acp(const DynLinArr<long>& ind) const
    {
      long q;
      if((q=qel.get_qel()) > ind.get_qel())
      { cout<<"ERROR in DynArr::acp(const DynLinArr<long>& ind): "
      <<"qel.get_qel()!= ind.get_qel()\n"
      <<"qel.get_qel()="<<qel.get_qel()
      <<" ind.get_qel()="<<ind.get_qel()
      <<'\n';
      cout<<"Type of T is (in internal notations) "<<typeid(T).name()<<'\n';
      {cout<<FunNameStack::instance(); cout<<"File is "<<"/home/ismirnov/s06/wcpplib/safetl/AbsArr.h"<<" , line number is "<<2086<<'\n'; spexit_action(cout); }; }







      if(q == 1)
 return el[ind.acu(0)];
      else
 return el.acu(calc_lin_ind(ind));







    }

  T& acu(const DynLinArr<long>& ind)
  {
    if(qel.get_qel() == 1)
      return el.acu(ind.acu(0));
    else
      return el.acu(calc_lin_ind(ind));
  }
  const T& acu(const DynLinArr<long>& ind) const
  {
    if(qel.get_qel() == 1)
      return el.acu(ind.acu(0));
    else
      return el.acu(calc_lin_ind(ind));
  }

  T& ac(long i1, long i2)
  {
    if(qel.get_qel() == 2)
    {

      if(i1 >= 0 && i1 < qel.acu(0))
      {
 if(i2 >= 0 && i2 < qel.acu(1))
 {



   return el.acu(i1*cum_qel.acu(0) + i2);

 }
 else
 {
   cout<<"Error in DynArr::ac(long i1, long i2): i2 < 0 || i2 >= qel.acu(1)\n";
   cout<<indn<<"i2"<<"="<<noindent<<i2<<", "<<"qel[1]"<<"="<<noindent<<qel[1]<<'\n'<<yesindent;;
 }
      }
      else
      {
 cout<<"Error in DynArr::ac(long i1, long i2): i1 < 0 || i1 >= qel.acu(0)\n";
 cout<<indn<<"i1"<<"="<<noindent<<i1<<", "<<"qel[0]"<<"="<<noindent<<qel[0]<<'\n'<<yesindent;;
      }
    }
    else
    {
      cout<<"ERROR in DynArr::ac(long i1, long i2): qel.get_qel()!= 2,"
    <<" qel.get_qel()=" <<qel.get_qel()<<'\n';
    }
    cout<<"Type of T is (in internal notations) "<<typeid(T).name()<<'\n';
    {cout<<FunNameStack::instance(); cout<<"File is "<<"/home/ismirnov/s06/wcpplib/safetl/AbsArr.h"<<" , line number is "<<2155<<'\n'; spexit_action(cout); };
  }
  const T& ac(long i1, long i2) const
  {
    if(qel.get_qel() == 2)
    {

      if(i1 >= 0 && i1 < qel.acu(0))
      {
 if(i2 >= 0 && i2 < qel.acu(1))
 {



   return el.acu(i1*cum_qel.acu(0) + i2);

 }
 else
 {
   cout<<"Error in DynArr::ac(long i1, long i2): i2 < 0 || i2 >= qel.acu(1)\n";
   cout<<indn<<"i2"<<"="<<noindent<<i2<<", "<<"qel[1]"<<"="<<noindent<<qel[1]<<'\n'<<yesindent;;
 }
      }
      else
      {
 cout<<"Error in DynArr::ac(long i1, long i2): i1 < 0 || i1 >= qel.acu(0)\n";
 cout<<indn<<"i1"<<"="<<noindent<<i1<<", "<<"qel[0]"<<"="<<noindent<<qel[0]<<'\n'<<yesindent;;
      }
    }
    else
    {
      cout<<"ERROR in DynArr::ac(long i1, long i2): qel.get_qel()!= 2,"
    <<" qel.get_qel()=" <<qel.get_qel()<<'\n';
    }
    cout<<"Type of T is (in internal notations) "<<typeid(T).name()<<'\n';
    {cout<<FunNameStack::instance(); cout<<"File is "<<"/home/ismirnov/s06/wcpplib/safetl/AbsArr.h"<<" , line number is "<<2229<<'\n'; spexit_action(cout); };
  }
  inline T& acu(long i1, long i2)
  {
    return el.acu(i1*cum_qel.acu(0) + i2);
  }
  inline const T& acu(long i1, long i2) const
  {
    return el.acu(i1*cum_qel.acu(0) + i2);
  }

  T& ac(long i1, long i2, long i3)
    {
      if(qel.get_qel() != 3)
      { cout<<"ERROR in DynArr::ac(long i1, long i2, long i3): qel.get_qel()!= 3,"
      <<" qel.get_qel()=" <<qel.get_qel()<<'\n';
      cout<<"Type of T is (in internal notations) "<<typeid(T).name()<<'\n';
      {cout<<FunNameStack::instance(); cout<<"File is "<<"/home/ismirnov/s06/wcpplib/safetl/AbsArr.h"<<" , line number is "<<2285<<'\n'; spexit_action(cout); }; }

    if(i1 < 0 || i1 >= qel.acu(0))
    {
      cout<<"Error in DynArr::ac(long i1, long i2, long i3): i1 < 0 || i1 >= qel.acu(0)\n";
      cout<<indn<<"i1"<<"="<<noindent<<i1<<", "<<"qel[0]"<<"="<<noindent<<qel[0]<<'\n'<<yesindent;;
      {cout<<FunNameStack::instance(); cout<<"File is "<<"/home/ismirnov/s06/wcpplib/safetl/AbsArr.h"<<" , line number is "<<2291<<'\n'; spexit_action(cout); };
    }
    if(i2 < 0 || i2 >= qel.acu(1))
    {
      cout<<"Error in DynArr::ac(long i1, long i2, long i3): i2 < 0 || i2 >= qel.acu(1)\n";
      cout<<indn<<"i2"<<"="<<noindent<<i2<<", "<<"qel[1]"<<"="<<noindent<<qel[1]<<'\n'<<yesindent;;
      {cout<<FunNameStack::instance(); cout<<"File is "<<"/home/ismirnov/s06/wcpplib/safetl/AbsArr.h"<<" , line number is "<<2297<<'\n'; spexit_action(cout); };
    }
    if(i3 < 0 || i3 >= qel.acu(2))
    {
      cout<<"Error in DynArr::ac(long i1, long i2, long i3): i3 < 0 || i3 >= qel.acu(2)\n";
      cout<<indn<<"i3"<<"="<<noindent<<i3<<", "<<"qel[2]"<<"="<<noindent<<qel[2]<<'\n'<<yesindent;;
      {cout<<FunNameStack::instance(); cout<<"File is "<<"/home/ismirnov/s06/wcpplib/safetl/AbsArr.h"<<" , line number is "<<2303<<'\n'; spexit_action(cout); };
    }



    return el[i1*cum_qel.acu(0) + i2*cum_qel[1] + i3];





    }


  const T& ac(long i1, long i2, long i3) const
  {
    if(qel.get_qel() != 3)
    { cout<<"ERROR in DynArr::ac(long i1, long i2, long i3): qel.get_qel()!= 3,"
    <<" qel.get_qel()=" <<qel.get_qel()<<'\n';
    cout<<"Type of T is (in internal notations) "<<typeid(T).name()<<'\n';
    {cout<<FunNameStack::instance(); cout<<"File is "<<"/home/ismirnov/s06/wcpplib/safetl/AbsArr.h"<<" , line number is "<<2323<<'\n'; spexit_action(cout); }; }

    if(i1 < 0 || i1 >= qel.acu(0))
    {
      cout<<"Error in DynArr::ac(long i1, long i2, long i3): i1 < 0 || i1 >= qel.acu(0)\n";
      cout<<indn<<"i1"<<"="<<noindent<<i1<<", "<<"qel[0]"<<"="<<noindent<<qel[0]<<'\n'<<yesindent;;
      {cout<<FunNameStack::instance(); cout<<"File is "<<"/home/ismirnov/s06/wcpplib/safetl/AbsArr.h"<<" , line number is "<<2329<<'\n'; spexit_action(cout); };
    }
    if(i2 < 0 || i2 >= qel.acu(1))
    {
      cout<<"Error in DynArr::ac(long i1, long i2, long i3): i2 < 0 || i2 >= qel.acu(1)\n";
      cout<<indn<<"i2"<<"="<<noindent<<i2<<", "<<"qel[1]"<<"="<<noindent<<qel[1]<<'\n'<<yesindent;;
      {cout<<FunNameStack::instance(); cout<<"File is "<<"/home/ismirnov/s06/wcpplib/safetl/AbsArr.h"<<" , line number is "<<2335<<'\n'; spexit_action(cout); };
    }
    if(i3 < 0 || i3 >= qel.acu(2))
    {
      cout<<"Error in DynArr::ac(long i1, long i2, long i3): i3 < 0 || i3 >= qel.acu(2)\n";
      cout<<indn<<"i3"<<"="<<noindent<<i3<<", "<<"qel[2]"<<"="<<noindent<<qel[2]<<'\n'<<yesindent;;
      {cout<<FunNameStack::instance(); cout<<"File is "<<"/home/ismirnov/s06/wcpplib/safetl/AbsArr.h"<<" , line number is "<<2341<<'\n'; spexit_action(cout); };
    }



    return el[i1*cum_qel.acu(0) + i2*cum_qel[1] + i3];





  }

  long get_qel_lin(void) const {return el.get_qel();}


  inline T& ac_lin(long n)
  {
    long qelln = el.get_qel();

    if( n>= 0 && n < qelln)
    {
      return el[n];
    }
    else
    {
      cout<<"ERROR in T& DynArr::ac_lin(long n): "
    <<"n is out of bounds, n="<<n
    <<" qelln="<<qelln<<'\n';
      cout<<"Type of T is (in internal notations) "<<typeid(T).name()<<'\n';
      {cout<<FunNameStack::instance(); cout<<"File is "<<"/home/ismirnov/s06/wcpplib/safetl/AbsArr.h"<<" , line number is "<<2371<<'\n'; spexit_action(cout); };




    }



  }
  inline const T& ac_lin(long n) const
  {
    long qelln = el.get_qel();

    if( n>= 0 && n < qelln)
    {
      return el[n];
    }
    else
    {
      cout<<"ERROR in T& DynArr::ac_lin(long n): "
    <<"n is out of bounds, n="<<n
    <<" qelln="<<qelln<<'\n';
      cout<<"Type of T is (in internal notations) "<<typeid(T).name()<<'\n';
      {cout<<FunNameStack::instance(); cout<<"File is "<<"/home/ismirnov/s06/wcpplib/safetl/AbsArr.h"<<" , line number is "<<2395<<'\n'; spexit_action(cout); };




    }



  }

  inline T& acu_lin(long n) {return el[n];}
  inline const T& acu_lin(long n) const {return el[n];}

  void assignAll(const T& val);

  long get_qdim(void) const { return qel.get_qel(); }
  const DynLinArr<long>& get_qel(void) const { return qel; }
  const DynLinArr<T>& get_el(void) const { return el; }


  const DynLinArr<long>& get_cum_qel(void) const { return cum_qel; }


  void put_qel(T* val=NULL);
  void clear(void) {qel.clear(); cum_qel.clear(); el.clear(); }

  int confirm_ind(const DynLinArr<long>& ind)
    {
      return gconfirm_ind(qel, ind);
    }
  int confirm_ind_ext(const DynLinArr<long>& ind)
    {
       return gconfirm_ind_ext(qel, ind);
    }
  DynArr<T> top(void);


  template<class P> friend void apply1(DynArr<P>& ar, void (*fun)(P& f));




  template<class P, class X> friend void apply2(DynArr<P>& ar,
   void (*fun1)(P& f, void (*fun21)(X& f) ),
   void (*fun2)(X& f) );

  void check(void) const { qel.check(); cum_qel.check(); el.check(); }
  int get_s_non_emplty(void) const
  {
    long q = qel.get_qel();
    if(q == 0) return 0;
    long n; for(n=0; n<q; n++){ if(qel[n] <=0) return 0;}
    return 1;
  }



  virtual ~DynArr(void) { }

private:
  mutable DynLinArr<long> qel;

  mutable DynLinArr<long> cum_qel;





  mutable DynLinArr<T> el;



  long calc_lin_ind(const DynLinArr<long>& ind) const
    {
      long i=0; long n; long qdim1=qel.get_qel() - 1;
      for( n=0; n<qdim1; n++)
      {
 if(ind.acu(n) < 0 || ind.acu(n) >= qel.acu(n))
 {
   cout<<"ERROR in long DynArr::calc_lin_ind(const DynLinArr<long>& ind) const\n";
   cout<<"ind.acu(n) < 0 || ind.acu(n) >= qel.acu(n)\n";
   cout<<indn<<"n"<<"="<<noindent<<n<<", "<<"ind[n]"<<"="<<noindent<<ind[n]<<", "<<"qel[n]"<<"="<<noindent<<qel[n]<<'\n'<<yesindent;;
   cout<<indn<<"qel"<<"="<<noindent<<qel<<'\n'<<yesindent;;
   {cout<<FunNameStack::instance(); cout<<"File is "<<"/home/ismirnov/s06/wcpplib/safetl/AbsArr.h"<<" , line number is "<<2511<<'\n'; spexit_action(cout); };
 }


 i += ind[n]*cum_qel[n];
      }
      if(ind.acu(qdim1) < 0 || ind.acu(qdim1) >= qel.acu(qdim1))
      {
 cout<<"ERROR in long DynArr::calc_lin_ind(const DynLinArr<long>& ind) const\n";
 cout<<"ind.acu(qdim1) < 0 || ind.acu(qdim1) >= qel.acu(qdim1)\n";
 cout<<indn<<"n"<<"="<<noindent<<n<<", "<<"ind[qdim1]"<<"="<<noindent<<ind[qdim1]<<", "<<"qel[qdim1]"<<"="<<noindent<<qel[qdim1]<<'\n'<<yesindent;;
 cout<<indn<<"qel"<<"="<<noindent<<qel<<'\n'<<yesindent;;
 {cout<<FunNameStack::instance(); cout<<"File is "<<"/home/ismirnov/s06/wcpplib/safetl/AbsArr.h"<<" , line number is "<<2534<<'\n'; spexit_action(cout); };
      }


      i += ind[qdim1];

      return i;
    }




};


template<class T>
DynArr<T>& DynArr<T>::operator=(const DynArr<T>& f)
{



  if(this != &f)
  {


    check();
    f.check();
    qel = f.qel;
    cum_qel = f.cum_qel;
    el = f.el;
  }
  return *this;
}

template<class T> template<class D>
DynArr<T>& DynArr<T>::operator=(const DynArr<D>& f)
{







    check();
    f.check();
    DynLinArr<long> qel = f.get_qel();
    DynLinArr<long> cum_qel = f.get_cum_qel();

    long q = f.get_qel_lin();
    T* temp_el = (q > 0) ? (new T[q]) : (T*)NULL;

    long n; for( n=0; n<q; n++) temp_el[n] = f.acu_lin(n);
    pass(q, qel, cum_qel, temp_el);

  return *this;
}


template<class T>
void apply1(DynArr<T>& ar, void (*fun)(T& f))
{
  long q = ar.el.get_qel();
  long n; for(n=0; n<q; n++) (*fun)(ar.el[n]);
}
template<class T, class X>
void apply2(DynArr<T>& ar,
     void (*fun1)(T& f, void (*fun21)(X& f) ),
     void (*fun2)(X& f) )
{
  long q = ar.el.get_qel();
  long n; for(n=0; n<q; n++) (*fun1)(ar.el[n], fun2);
}

int find_next_comb(const DynLinArr<long>& qel, DynLinArr<long>& f);
int find_prev_comb(const DynLinArr<long>& qel, DynLinArr<long>& f);
int find_next_comb_not_less(const DynLinArr<long>& qel, DynLinArr<long>& f);


template<class T> class IterDynArr
{public:
  IterDynArr(const DynArr<T>* fdar):
    ncur(fdar->get_qdim()), dar((DynArr<T>*)fdar)
    {
      long n; long qdim1=ncur.get_qel()-1;
      if(qdim1>=0) {for( n=0; n<qdim1; n++) ncur[n] = 0; ncur[qdim1] = -1; }
    }
  T* more(void)
    {
      if( find_next_comb(dar->get_qel(), ncur) )
 return &(dar->ac(ncur));
      else
 return NULL;
    }

  T* current(void)
    {
      long n; long qdim=ncur.get_qel(); if(qdim <=0 ) return NULL;
      for( n=0; n<qdim; n++ )
      { if(ncur[n] < 0 || ncur[n] >= dar->get_qel()[n]) return NULL; }
      return &(dar->ac(ncur));
    }

  T* less(void)

    {
      if( find_prev_comb(dar->get_qel(), ncur) )
 return &(dar->ac(ncur));
      else
 return NULL;
    }

  const DynLinArr<long>& get_ncur(void) const { return ncur; }
private:
  DynLinArr<long>ncur;
  DynArr<T>* dar;
};

extern DynLinArr<long> qel_communicat;

template<class T>
void DynArr<T>::put_qel(T* val)

{
  check();
  if(qel.get_qel() == 0)
  {
    *this=DynArr<T>(qel_communicat, val); return;
  }

  DynArr<T> datemp(qel_communicat, val);
  IterDynArr<T> iter(&datemp);
  T* at;
  while( (at=iter.more()) != NULL )
  {
    if(confirm_ind_ext(iter.get_ncur()))
      *at=acp(iter.get_ncur());
  }
  *this = datemp;
}

template<class T>
int operator==(const DynLinArr<T>& f1, const DynLinArr<T>& f2)
{
  if(f1.get_qel() != f2.get_qel()) return 0;
  long q=f1.get_qel();
  long n;
  for( n=0; n<q; n++)
  {
    if( !(f1.acu(n) == f2.acu(n)) ) return 0;
  }
  return 1;
}

template<class T, class P>
int apeq_mant(const DynLinArr<T>& f1, const DynLinArr<T>& f2, P prec)
{
  if(f1.get_qel() != f2.get_qel()) return 0;
  long q=f1.get_qel();
  long n;
  for( n=0; n<q; n++)
  {
    if( !apeq_mant(f1.acu(n), f2.acu(n), prec) ) return 0;
  }
  return 1;
}

template<class T>
int operator!=(const DynLinArr<T>& f1, const DynLinArr<T>& f2)
{
  if(f1 == f2) return 0;
  else return 1;
}


template<class T>
int operator==(const DynArr<T>& f1, const DynArr<T>& f2)
{
  if(f1.get_qel() != f2.get_qel()) return 0;
  if(f1.get_el() != f2.get_el()) return 0;
  return 1;
}

template<class T, class P>
int apeq_mant(const DynArr<T>& f1, const DynArr<T>& f2, P prec)
{
  if(f1.get_qel() != f2.get_qel()) return 0;
  if(!apeq_mant(f1.get_el(), f2.get_el(), prec)) return 0;
  return 1;
}

template<class T>
int operator!=(const DynArr<T>& f1, const DynArr<T>& f2)
{
  if(f1.get_qel() == f2.get_qel()) return 0;
  if(f1.get_el() == f2.get_el()) return 0;
  return 1;
}

template<class T>
void DynArr<T>::assignAll(const T& val)
{
  check();

  el.assignAll(val);
}

template<class T, class X>
void copy_DynArr(const DynArr<T>& s, DynArr<X>& d)
{
  static const char* FunNameIIII="template<class T, class X> void copy_DynArr(const DynArr<T>& s, DynArr<X>& d)"; FunNameWatch funnw(FunNameIIII);
  s.check(); d.check();
  d = DynArr<X>(s.get_qel(), NULL);
  IterDynArr<T> iter(&s);
  T* at;
  while( (at=iter.more()) != NULL )
  {
    const DynLinArr<long>& ncur = iter.get_ncur();
    d.ac(ncur) = *at;
  }
}


template<class T, class X>
void convert_DynArr(const DynArr<T>& s, DynArr<X>& d)
{
  static const char* FunNameIIII="template<class T, class X> void convert_DynArr(const DynArr<T>& s, DynArr<X>& d)"; FunNameWatch funnw(FunNameIIII);
  s.check(); d.check();
  d = DynArr<X>(s.get_qel(), NULL);
  IterDynArr<T> iter(&s);
  T* at;
  while( (at=iter.more()) != NULL )
  {
    const DynLinArr<long>& ncur = iter.get_ncur();
    d.ac(ncur) = X(*at);
  }
}

template<class T>
DynArr<T> DynLinArr<T>::top(void)
{
  check();
  DynArr<T> r(1, qel);
  long n;
  for(n=0; n<qel; n++)
  {
    r.ac(0,n) = el[n];
  }
  return r;
}
template<class T>
DynArr<T> DynArr<T>::top(void)
{
  static const char* FunNameIIII="template<class T> DynArr<T> DynArr<T>::top(void)"; FunNameWatch funnw(FunNameIIII);
  check();
  long qdim=get_qdim();
  if(qdim != 2) { cout<<"ERROR:\n"; cout<<'\n'<<"qdim"<<"!= 2"<<'\n'; cout<<"qdim"<<'='<<(qdim)<<'\n'; {cout<<FunNameStack::instance(); cout<<"File is "<<"/home/ismirnov/s06/wcpplib/safetl/AbsArr.h"<<" , line number is "<<2807<<'\n'; spexit_action(cout); }; };
  long n1, n2;
  DynArr<T> r(qel[1], qel[0]);
  for(n1=0; n1<qel[0]; n1++)
  {
    for(n2=0; n2<qel[1]; n2++)
    {
      r.ac(n2,n1) = ac(n1,n2);
    }
  }
  return r;
}

template<class T>
DynLinArr<T>::DynLinArr(const DynArr<T>& f)
{

  f.check();
  long qdim=f.get_qdim();
  if(qdim != 1)
  {
    cout<<"ERROR in DynLinArr<T>::DynLinArr(const DynArr<T>& f):\n"
  <<"f.get_qdim() != 1, f.get_qdim()="<<f.get_qdim()<<'\n';
    cout<<"Type of T is (in internal notations) "<<typeid(T).name()<<'\n';
    {cout<<FunNameStack::instance(); cout<<"File is "<<"/home/ismirnov/s06/wcpplib/safetl/AbsArr.h"<<" , line number is "<<2831<<'\n'; spexit_action(cout); };
  }
  const DynLinArr<long>& qelem=f.get_qel();
  qel=qelem[0];

  if(qel > 0)
  {




    el=new T[qel];

    long n;
    for(n=0; n<qel; n++)
      el[n]=f.ac(n);
  }
  else
    el=NULL;
}


template<class T>
DynLinArr<T>::DynLinArr(const DynArr<T>& f, int n_of_dim,

     long roc_number)

{
  f.check();
  long qdim=f.get_qdim();
  if(qdim != 2)
  {
    cout<<"ERROR in DynLinArr<T>::DynLinArr(const DynArr<T>& f, int n_of_dim,long roc_number):\n"
  <<"f.get_qdim() != 2, f.get_qdim()="<<f.get_qdim()<<'\n';
    cout<<"Type of T is (in internal notations) "<<typeid(T).name()<<'\n';
    {cout<<FunNameStack::instance(); cout<<"File is "<<"/home/ismirnov/s06/wcpplib/safetl/AbsArr.h"<<" , line number is "<<2866<<'\n'; spexit_action(cout); };
  }
  const DynLinArr<long>& qelem=f.get_qel();
  if(n_of_dim == 0)
  {
    qel = qelem[1];
  }
  else
  {
    qel = qelem[0];
  }

  if(qel > 0)
  {




    el=new T[qel];

    long n;
    if(n_of_dim == 0)
    {
      for(n=0; n<qel; n++)
 el[n]=f.ac(roc_number, n);
    }
    else
    {
      for(n=0; n<qel; n++)
 el[n]=f.ac(n, roc_number);
    }
  }
}


template<class T>
ostream& operator<<(ostream& file, const DynArr<T>& f)
{

  f.check();
  file<<indn<<"DynArr<T>: qdim="<<f.get_qdim()<<'\n';
  indn.n+=2;
  if(s_short_output > 0)
  {
    file<<indn<<noindent<<f.get_qel()<<yesindent;
  }
  else
  {
    file<<indn<<"qel="<<noindent<<f.get_qel()<<yesindent;
    file<<indn<<"cum_qel="<<noindent<<f.get_cum_qel()<<yesindent;
  }
  if(f.get_s_non_emplty() == 1)
  {
    if(s_short_output == 0)
    {
      file<<indn<<"Content element by element:\n";
      file<<indn<<"(The first number is sequencial number, then there are indexes, the last is the element)\n";

    }
    long nseq=0;
    IterDynArr<T> iter_f( &((DynArr<T>&) f));
    T* at;
    while( (at=iter_f.more()) != NULL )
    {
      std::ostringstream ost;
      if(s_short_output == 0)
      {

 file<<indn<<"nseq="<<setw(5)<<nseq<<" ncur=";
 long n;
 for(n=0; n<iter_f.get_ncur().get_qel(); n++)
 {
   file<<' '<<setw(5)<<iter_f.get_ncur()[n];
 }
 ost<<indn<<" element="<<noindent<<(*at)<<yesindent;
      }
      else
      {
 ost<<indn<<noindent<<(*at)<<yesindent;
      }
      put_one_n(ost);
      file<<ost.str();
      nseq++;
    }
    file<<yesindent;
  }
  else
  {
    if(s_short_output == 0)
    {
      file<<indn<<"Content is empty.\n";
    }
  }
  indn.n-=2;
  return file;
}
template<class T>
istream& operator>>(istream& file, DynArr<T>& f)
{
  static const char* FunNameIIII="template<class T> istream& operator>>(istream& file, DynArr<T>& f)"; FunNameWatch funnw(FunNameIIII);
  definp_endpar dep(&file, 0, 1, 0, s_short_output);
  long qdim=0;
  dep.s_short = 0;
  definp_any_par(qdim, String("qdim""="), dep );
  dep.s_short = s_short_output;
  if(qdim < 0) { cout<<"ERROR:\n"; cout<<'\n'<<"qdim"<<"< 0"<<'\n'; cout<<"qdim"<<'='<<(qdim)<<'\n'; {cout<<FunNameStack::instance(); cout<<"File is "<<"/home/ismirnov/s06/wcpplib/safetl/AbsArr.h"<<" , line number is "<<2999<<'\n'; spexit_action(cout); }; };
  if(s_short_output == 0)
  {
    set_position("qel=DynLinArr<T>:", *dep.istrm, dep.s_rewind, dep.s_req_sep);
  }
  else
  {
    set_position("DynLinArr<T>:", *dep.istrm, dep.s_rewind, dep.s_req_sep);
  }
  DynLinArr<long> qel_loc;

  file>>qel_loc;

  if(s_short_output == 0)
  {
    set_position("cum_qel=DynLinArr<T>:",
   *dep.istrm, dep.s_rewind, dep.s_req_sep);
    DynLinArr<long> cum_qel_loc;
    file>>cum_qel_loc;
  }
  if(qel_loc.get_qel() > 0 )
  {
    f.pilfer(DynArr<T>(qel_loc, NULL));
    long nseq;
    long n;
    long qseq=qel_loc[0];
    for(n=1; n<qel_loc.get_qel(); n++)
    {
      qseq*=qel_loc[n];
    }
    for(n=0; n<qseq; n++)
    {
      if(s_short_output == 0)
      {
 definp_any_par(nseq, String("nseq""="), dep );
 if(nseq != n) { cout<<"ERROR:\n"; cout<<'\n'<<"nseq"<<"!="<<"n"<<'\n'; cout<<"nseq"<<'='<<(nseq)<<' '<<"n"<<'='<<(n)<<'\n'; {cout<<FunNameStack::instance(); cout<<"File is "<<"/home/ismirnov/s06/wcpplib/safetl/AbsArr.h"<<" , line number is "<<3034<<'\n'; spexit_action(cout); }; };
 DynLinArr< long > ncur(qel_loc.get_qel());
 set_position("ncur=",
       *dep.istrm, dep.s_rewind, dep.s_req_sep);
 long m;
 for(m=0; m<qel_loc.get_qel(); m++)
 {
   file>>ncur[m];
 }



 set_position("element=",
       *dep.istrm, dep.s_rewind, dep.s_req_sep);
      }
      file>>f.ac_lin(n);
    }
  }
  else
  {
    if(s_short_output == 0)
    {

      set_position("Content is empty.",
     *dep.istrm, dep.s_rewind, dep.s_req_sep);
    }
    f.pilfer(DynArr<T>());

  }
  return file;
}
template<class T>
void print_DynArr(ostream& file, const DynArr<T>& f, int l)
{

  f.check();


  file<<indn<<"DynArr<T>: qdim="<<f.get_qdim()<<'\n';
  indn.n+=2;
  file<<indn<<"qel="<<noindent<<f.get_qel()<<yesindent;
  file<<indn<<"cum_qel="<<noindent<<f.get_cum_qel()<<yesindent;
  file<<indn<<"Content element by element:\n";
  file<<indn<<"(The first number is sequencial number, then there are indexes, the last is the element)\n";

  long nseq=0;
  IterDynArr<T> iter_f( &((DynArr<T>&) f));
  T* at;
  while( (at=iter_f.more()) != NULL )
  {

    file<<indn<<"nseq="<<setw(5)<<nseq<<" ncur=";
    long n;
    for(n=0; n<iter_f.get_ncur().get_qel(); n++)
    {
      file<<' '<<setw(5)<<iter_f.get_ncur()[n];
    }



    std::ostringstream ost;
    ost<<indn<<" element="<<noindent;
    at->print(ost, l);
    ost<<yesindent;
    put_one_n(ost);
    file<<ost.str();
  }
  file<<yesindent;
  indn.n-=2;

}





void print_DynArr_int_w(ostream& file, const DynArr<int>& f, int w);

void print_DynArr_float(ostream& file, const DynArr<float>& f);
void print_DynArr_double(ostream& file, const DynArr<double>& f);
long max_qel_DynLinArr=100000000;

void print_DynLinArr_int(ostream& file, const DynLinArr<int>& f)
{
  file<<indn<<"DynLinArr<int>:";
  long q=f.get_qel();
  file<<" q="<<q<<'\n';
  f.check();
  if( q <= 0 ) return;
  indn.n+=2;
  if(q <= pq_arrelem_in_line) file<<indn;
  long i;
  for( i=0; i<q; i++)
  {
    if(q <= pq_arrelem_in_line)
      file<<f[i]<<' ';
    else
      file<<indn<<setw(4)<<i<<' '<<f[i]<<'\n';
  }
  if(q<=pq_arrelem_in_line) file<<'\n';
  indn.n-=2;
  file<<flush;
}
void print_DynLinArr_long(ostream& file, const DynLinArr<long>& f)
{
  file<<indn<<"DynLinArr<long>:";
  long q=f.get_qel();
  file<<" q="<<q<<'\n';
  f.check();
  if( q <= 0 ) return;
  indn.n+=2;
  if(q <= pq_arrelem_in_line) file<<indn;
  long i;
  for( i=0; i<q; i++)
  {
    if(q <= pq_arrelem_in_line)
      file<<f[i]<<' ';
    else
      file<<indn<<setw(4)<<i<<' '<<f[i]<<'\n';
  }
  if(q<=pq_arrelem_in_line) file<<'\n';
  indn.n-=2;
  file<<flush;
}

void print_DynLinArr_float(ostream& file, const DynLinArr<float>& f)
{
  file<<indn<<"DynLinArr<float>:";
  long q=f.get_qel();
  file<<" q="<<q<<'\n';
  f.check();
  if( q <= 0 ) return;
  indn.n+=2;
  if(q <= pq_arrelem_in_line) file<<indn;
  long i;
  for( i=0; i<q; i++)
  {
    if(q <= pq_arrelem_in_line)
      file<<f[i]<<' ';
    else
      file<<indn<<setw(4)<<i<<' '<<f[i]<<'\n';
  }
  if(q<=pq_arrelem_in_line) file<<'\n';
  indn.n-=2;
  file<<flush;
}

void print_DynLinArr_double(ostream& file, const DynLinArr<double>& f)
{
  file<<indn<<"DynLinArr<double>:";
  long q=f.get_qel();
  file<<" q="<<q<<'\n';
  f.check();
  if( q <= 0 ) return;
  indn.n+=2;
  if(q <= pq_arrelem_in_line) file<<indn;
  long i;
  for( i=0; i<q; i++)
  {
    if(q <= pq_arrelem_in_line)
      file<<f[i]<<' ';
    else
      file<<indn<<setw(4)<<i<<' '<<f[i]<<'\n';
  }
  if(q<=pq_arrelem_in_line) file<<'\n';
  indn.n-=2;
  file<<flush;
}

void print_DynLinArr_double2(ostream& file,
        const DynLinArr<double>& f1,
        const DynLinArr<double>& f2)
{
  file<<indn<<"Two arrays DynLinArr<double>:";
  long q1=f1.get_qel();
  long q2=f2.get_qel();
  long q_max = q1;
  if(q_max > q2) q_max = q2;
  file<<" q1="<<q1<<" q2="<<q2<<'\n';
  f1.check();
  f2.check();
  if( q_max <= 0 ) return;
  indn.n+=2;
  if(q_max <= pq_arrelem_in_line) file<<indn;
  if(q_max >= pq_arrelem_in_line)
  {
    file<<indn<<"index            array1             array2\n";
    long i;
    for( i=0; i<q_max; i++)
    {
      file<<indn<<setw(4)<<i<<' ';
      if(i<q1)
 file<<setw(18)<<f1[i]<<' ';
      else
 file<<"                   ";
      if(i<q2)
 file<<setw(18)<<f2[i]<<'\n';
      else
 file<<"                  \n";
    }
  }
  else
  {
    long i;
    file<<indn<<"array1=";
    for( i=0; i<q1; i++)
    {
      file<<setw(18)<<f1[i]<<' ';
    }
    file<<'\n';
    file<<indn<<"array2=";
    for( i=0; i<q2; i++)
    {
      file<<setw(18)<<f2[i]<<' ';
    }
    file<<'\n';
  }
  indn.n-=2;
  file<<flush;
}

void print_DynLinArr_int_double(ostream& file,
     const DynLinArr<int>& iar,
     const DynLinArr<double>& dar)
{
  file<<indn<<"One DynLinArr<int> array and one DynLinArr<double>:\n";
  long qiar = iar.get_qel();
  long qdar = dar.get_qel();
  long q_max = qiar;
  if(q_max < qdar) q_max = qdar;
  indn.n+=2;

  file<<indn<<" qiar="<<qiar
       <<" qdar="<<qdar<<'\n';
  iar.check();
  dar.check();
  if( q_max <= 0 ) {indn.n -= 2; return;}
  file<<indn<<"index int array    double array\n";
  long i;
  for( i=0; i<q_max; i++)
  {
    file<<indn<<setw(4)<<i<<' ';
    if(i<qiar)
      file<<setw(8)<<iar[i]<<' ';
    else
      file<<"         ";
    if(i<qdar)
      file<<setw(18)<<dar[i]<<' ';
    else
      file<<"                   ";
  }
  indn.n-=2;
  file<<flush;
}


void print_DynLinArr_int_double3(ostream& file,
     const DynLinArr<int>& iar,
     const DynLinArr<double>& dar1,
     const DynLinArr<double>& dar2,
     const DynLinArr<double>& dar3)
{
  file<<indn<<"One DynLinArr<int> array and three arrays DynLinArr<double>:\n";
  long qiar = iar.get_qel();
  long qdar1 = dar1.get_qel();
  long qdar2 = dar2.get_qel();
  long qdar3 = dar3.get_qel();
  long q_max = qiar;
  if(q_max < qdar1) q_max = qdar1;
  if(q_max < qdar2) q_max = qdar2;
  if(q_max < qdar3) q_max = qdar3;
  indn.n+=2;

  file<<indn<<"qiar="<<qiar
       <<" qdar1="<<qdar1<<" qdar2="<<qdar2<<" qdar3="<<qdar3<<'\n';
  iar.check();
  dar1.check();
  dar2.check();
  dar3.check();
  if( q_max <= 0 ) {indn.n -= 2; return;}
  file<<indn<<"index int array    double array1      double array2      double array3\n";
  long i;
  for( i=0; i<q_max; i++)
  {
    file<<indn<<setw(4)<<i<<' ';
    if(i<qiar)
      file<<setw(8)<<iar[i]<<' ';
    else
      file<<"         ";
    if(i<qdar1)
      file<<setw(18)<<dar1[i]<<' ';
    else
      file<<"                   ";
    if(i<qdar2)
      file<<setw(18)<<dar2[i]<<' ';
    else
      file<<"                   ";
    if(i<qdar3)
      file<<setw(18)<<dar3[i]<<'\n';
    else
      file<<"                  \n";
  }
  indn.n-=2;
  file<<flush;
}


void print_DynArr_int_w(ostream& file, const DynArr<int>& f, int w)
{
  ;
  f.check();
  file<<indn<<"DynArr<int>:";
  long qdim=f.get_qdim();
  file<<" qdim="<<qdim<<" sizes:";
  const DynLinArr<long>& qe=f.get_qel();
  qe.check();
  long n;
  for( n=0; n<qdim; n++)
  {
    file<<' '<<qe[n];
  }
  file<<'\n';
  indn.n+=2;
  if(qdim == 1)
  {
    long q=qe[0];
    if( q <= 0 ) return;
    indn.n+=2;
    if(indn.n + 3 + q * (w+1) <= 80)
    {
      file<<indn<<"ar=";
      long i;
      for( i=0; i<q; i++)
      {
 file<<' '<<setw(w)<<f.ac(i);
      }
      file<<'\n';
    }
    else
    {
      file<<indn<<"array:\n";
      long i;
      for( i=0; i<q; i++)
      {
 file<<indn<<setw(4)<<i<<' '<<f.ac(i)<<'\n';
      }
    }
  }
  else if(qdim == 2)
  {
    long qr = qe[0];
    long qc = qe[1];
    if( qr <= 0 && qc <= 0 ) return;
    indn.n+=2;
    if(indn.n + 3 + qc * (w+1) <= 80)
    {
      file<<indn<<"first index - columns, second index - lines\n";
      file<<indn<<"first index\n";
      long ir, ic;
      for( ir=0; ir<qr; ir++)
      {
 file<<indn<<setw(3)<<ir;
 for( ic=0; ic<qc; ic++)
 {
   file<<indn<<' '<<setw(w)<<f.ac(ir,ic);
 }
 file<<'\n';
      }
    }
    else if(indn.n + 3 + qr * (w+1) <= 80)
    {
      cout<<indn<<"first index - lines, second index - columns\n";
      cout<<indn<<"second index\n";
      long ir, ic;
      for( ic=0; ic<qc; ic++)
      {
 file<<indn<<setw(3)<<ic;
 for( ir=0; ir<qr; ir++)
 {
   file<<indn<<' '<<setw(w)<<f.ac(ir,ic);
 }
 file<<'\n';
      }
    }
    else
    {
      file<<indn<<" row  col  value of element\n";
      long ir, ic;
      for( ir=0; ir<qr; ir++)
      {
 for( ic=0; ic<qc; ic++)
 {
   file<<indn<<setw(4)<<ir<<' '<<setw(4)<<ic<<' '<<f.ac(ir,ic)
        <<'\n';
 }
      }
    }
  }
  else
  {
    IterDynArr<int> iter_f( &((DynArr<int>&) f));
    int* at;
    while( (at=iter_f.more()) != NULL )
    {
      file<<indn<<"ncur="<<noindent<<iter_f.get_ncur()<<yesindent;
      file<<indn<<"element="<<noindent<<(*at)<<yesindent<<'\n';
    }
    file<<yesindent;
  }

  indn.n-=2;







}


void print_DynArr_double(ostream& file, const DynArr<double>& f)
{
  ;
  f.check();
  file<<indn<<"DynArr<double>:";
  long qdim=f.get_qdim();
  file<<" qdim="<<qdim<<" sizes:";
  const DynLinArr<long>& qe=f.get_qel();
  qe.check();
  long n;
  for( n=0; n<qdim; n++)
  {
    file<<' '<<qe[n];
  }
  file<<'\n';
  if(qdim == 1)
  {
    long q=qe[0];
    if( q <= 0 ) return;
    indn.n+=2;
    if(q <= pq_arrelem_in_line) file<<indn;
    long i;
    for( i=0; i<q; i++)
    {
      if(q <= pq_arrelem_in_line)
      file<<f.ac(i)<<' ';
      else
 file<<indn<<setw(4)<<i<<' '<<f.ac(i)<<'\n';
    }
    if(q<=pq_arrelem_in_line) file<<'\n';
    indn.n-=2;
  }
  else if(qdim == 2)
  {
    long qr = qe[0];
    long qc = qe[1];
    if( qr <= 0 && qc <= 0 ) return;
    indn.n+=2;
    if(qc > pq_arrelem_in_line)
      file<<indn<<" row  col  value of element\n";
    long ir, ic;
    for( ir=0; ir<qr; ir++)
    {
      if(qc <= pq_arrelem_in_line) file<<indn;
      for( ic=0; ic<qc; ic++)
      {
 if(qc <= pq_arrelem_in_line)
   file<<f.ac(ir,ic)<<' ';
 else
   file<<indn<<setw(4)<<ir<<' '<<setw(4)<<ic<<' '<<f.ac(ir,ic)
        <<'\n';
      }
      if(qc <= pq_arrelem_in_line) file<<'\n';
    }

    indn.n-=2;
  }
  else
  {
    file<<f;
  }
}

void print_DynArr_float(ostream& file, const DynArr<float>& f)
{
  ;
  f.check();
  file<<indn<<"DynArr<float>:";
  long qdim=f.get_qdim();
  file<<" qdim="<<qdim<<" sizes:";
  const DynLinArr<long>& qe=f.get_qel();
  qe.check();
  long n;
  for( n=0; n<qdim; n++)
  {
    file<<' '<<qe[n];
  }
  file<<'\n';
  if(qdim == 1)
  {
    long q=qe[0];
    if( q <= 0 ) return;
    indn.n+=2;
    if(q <= pq_arrelem_in_line) file<<indn;
    long i;
    for( i=0; i<q; i++)
    {
      if(q <= pq_arrelem_in_line)
      file<<f.ac(i)<<' ';
      else
 file<<indn<<setw(4)<<i<<' '<<f.ac(i)<<'\n';
    }
    if(q<=pq_arrelem_in_line) file<<'\n';
    indn.n-=2;
  }
  else if(qdim == 2)
  {
    long qr = qe[0];
    long qc = qe[1];
    if( qr <= 0 && qc <= 0 ) return;
    indn.n+=2;
    if(qc > pq_arrelem_in_line)
      file<<indn<<" row  col  value of element\n";
    long ir, ic;
    for( ir=0; ir<qr; ir++)
    {
      if(qc <= pq_arrelem_in_line) file<<indn;
      for( ic=0; ic<qc; ic++)
      {
 if(qc <= pq_arrelem_in_line)
   file<<f.ac(ir,ic)<<' ';
 else
   file<<indn<<setw(4)<<ir<<' '<<setw(4)<<ic<<' '<<f.ac(ir,ic)
        <<'\n';
      }
      if(qc <= pq_arrelem_in_line) file<<'\n';
    }

    indn.n-=2;
  }
  else
  {
    file<<f;
  }
}


int gconfirm_ind(const DynLinArr<long>& qel, const DynLinArr<long>& ind)
{
  if(qel.get_qel() != ind.get_qel())
  { cout<<"gconfirm_ind(...): "
  <<"qel.get_qel()!= ind.get_qel()\n"
  <<"qel.get_qel()="<<qel.get_qel()
  <<"ind.get_qel()="<<ind.get_qel()
  <<'\n'; {cout<<FunNameStack::instance(); cout<<"File is "<<"ssdir.c"<<" , line number is "<<524<<'\n'; spexit_action(cout); }; }
  long qd=qel.get_qel();

  long n;
  for( n=0; n<qd; n++)
    if( ind[n] < 0 || ind[n] >= qel[n] ) return 0;
  return 1;
}
int gconfirm_ind_ext(const DynLinArr<long>& qel, const DynLinArr<long>& ind)
{
  if(qel.get_qel() > ind.get_qel())
  { cout<<"gconfirm_ind_ext(...): "
  <<"qel.get_qel()> ind.get_qel()\n"
  <<"qel.get_qel()="<<qel.get_qel()
  <<" ind.get_qel()="<<ind.get_qel()
  <<'\n'; {cout<<FunNameStack::instance(); cout<<"File is "<<"ssdir.c"<<" , line number is "<<539<<'\n'; spexit_action(cout); }; }
  long qd=qel.get_qel();
  long n;
  for( n=0; n<qd; n++)
    if( ind[n] < 0 || ind[n] >= qel[n] ) return 0;
  for( n=qd; n<ind.get_qel(); n++)
    if( ind[n] != 0 ) return 0;
  return 1;
}

int find_next_comb(const DynLinArr<long>& qel, DynLinArr<long>& f)
{
  long n; long qdim=qel.get_qel(); if(qdim <=0 ) return 0;
  if(qdim != f.get_qel()) return 0;
  for( n=qdim-1; n>=0; n--)
  {
    if(f.acu(n) < qel.acu(n) - 1)
    { f.acu(n)++; return 1; }
    else
    { f.acu(n)=0; }

  }
  for( n=0; n<qdim-1; n++)
    f.acu(n)=qel.acu(n) - 1;
  f.acu(qdim-1) = qel.acu(qdim-1);

  return 0;
}

int find_next_comb_not_less(const DynLinArr<long>& qel, DynLinArr<long>& f)
{
  long n; long qdim=qel.get_qel(); if(qdim <=0 ) return 0;
  if(qdim != f.get_qel()) return 0;
  for( n=qdim-1; n>=0; n--)
  {
    if(f[n] < qel[n] - 1)
    {
      f[n]++;
      int n1;
      for( n1=n+1; n1<qdim; n1++)
 f[n1]=f[n];
      return 1;
    }
  }
  for( n=0; n<qdim-1; n++)
    f[n]=qel[n] - 1;
  f[qdim-1] = qel[qdim-1];
  return 0;
}

int find_prev_comb(const DynLinArr<long>& qel, DynLinArr<long>& f)
{
  long n; long qdim=qel.get_qel(); if(qdim <=0 ) return 0;
  if(qdim != f.get_qel()) return 0;
  for( n=qdim-1; n>=0; n--)
  {
    if(f[n] >= 1)
    { f[n]--; return 1; }
    else
    { f[n]=qel[n] - 1; }
  }
  for( n=0; n<qdim-1; n++)
    f[n]=0;
  f[qdim-1] = -1; return 0;
}



DynLinArr<long> qel_communicat;
int s_throw_exception_in_spexit = 0;
int s_exit_without_core = 0;

FunNameStack& FunNameStack::instance()
{
  static FunNameStack* inst = NULL;
  if (!inst) inst = new FunNameStack();







  return *inst;
}


FunNameStack::FunNameStack(void):
  s_init(1), s_act(1), s_print(0), nmode(0)
{
  qname = 0;
  for( int n=0; n<pqname; n++) name[n]=NULL;

}
ostream& FunNameStack::printname(ostream& file, int n)

{



  file<<name[n]; return file;

}

void spexit_action(ostream& file)
{
  file<<"spexit_action: the streams will be now flushed\n";
  file.flush(); cout.flush(); cout.flush();
  if(s_throw_exception_in_spexit != 1)
  {
    if(s_exit_without_core == 1)
    {
      file<<"spexit_action: the exit(1) function is called\n";
      exit(1);
    }
    else
    {
      file<<"spexit_action: the abort function is called\n";
      abort();
    }
  }
  else
  {
    file<<"spexit_action: an exception is now called\n";
    throw ExcFromSpexit();
  }
}

FunNameStack::FunNameStack( const FunNameStack& f)
{
  *this = f;
}

FunNameStack& FunNameStack::operator=(const FunNameStack& f)
{
  if(this == &(FunNameStack::instance()) )
  {
    cout<<"ERROR in FunNameStack& FunNameStack::operator=(const FunNameStack& f)\n";
    cout<<"Attempt to copy to operative FunNameStack\n";
    cout<<"You don't need and should not initialize main FunNameStack directly\n";
    cout<<"If you want to change its parameters, use FunNameStack::instance()\n";
    cout<<indn<<"this"<<"="<<noindent<<this<<'\n'<<yesindent;;
    cout<<indn<<"&(FunNameStack::instance())"<<"="<<noindent<<&(FunNameStack::instance())<<'\n'<<yesindent;;
    cout<<indn<<"(*this)"<<"="<<noindent<<(*this)<<'\n'<<yesindent;;
    cout<<indn<<"(FunNameStack::instance())"<<"="<<noindent<<(FunNameStack::instance())<<'\n'<<yesindent;;

    {cout<<FunNameStack::instance(); cout<<"File is "<<"ssdir.c"<<" , line number is "<<976<<'\n'; spexit_action(cout); };
  }
  qname = f.qname;

  s_init = f.s_init;
  s_act = f.s_act;
  s_print = f.s_print;
  nmode = f.nmode;


  int n;
  for( n=0; n<f.qname; n++)
  {
    if(nmode == 0)
    {
      name[n] = f.name[n];
    }
    else
    {
      int l = strlen(f.name[n])+1;



      name[n] = new char[l]; strcpy(name[n],f.name[n]);



   }
  }

  return *this;
}

void FunNameStack::set_parameters(int fs_act, int fs_print)
{
  s_act = fs_act; s_print=fs_print;
}

FunNameStack::~FunNameStack()
{
  int n;



  if(nmode==1) for( n=0; n<qname; n++) delete name[n];




}







void FunNameStack::printput(ostream& file)
{
  if(s_print==1 || s_print==2)
  {







    file<<"FunNameStack::put: qname ="<<qname
 <<" last name=";
    printname(file,qname-1)<<'\n';

  }
  else if(s_print>=3)
  {




    file<<"FunNameStack::put:\n"<<(*this);

  }
}
void FunNameStack::printdel(ostream& file)
{
  if(s_print==2)
  {







    file<<"FunNameStack::del: qname ="<<qname
 <<" last name=";
    printname(file,qname-1)<<'\n';

  }
  else if(s_print==4)
  {
    file<<"FunNameStack::del:\n"<<(*this);
  }
}

ostream& operator<<(ostream& file, const FunNameStack& f)
{
  if(f.s_act == 1)
  {
    file<<"FunNameStack: s_init="<<f.s_init<<" qname="<<f.qname<<'\n';
    int n;
    for( n=0; n<f.qname; n++)
    {

      file<<setw(3)<<n<<"  "<<f.name[n]<<' '<<'\n';
    }

  }
  return file;
}

ostream& operator<<(ostream& file, const FunNameWatch& f)
{
  f.hdr(file);
  return file;
}


void GenError::print(ostream& file)
{
  file<<"GenError::print: ERROR detected in:\n"
      <<static_cast<FunNameStack*>(this)<<'\n';

}
void GenError::finish(ostream& file)
{
  print(file); exit(1);
}
template<class T>class AbsList;
template<class T>class AbsListNode;

template<class T>
AbsListNode<T>* glob_insert_before(AbsList<T>&, AbsListNode<T>*, const T& fel);
template<class T>
AbsListNode<T>* glob_insert_after(AbsList<T>&, AbsListNode<T>*, const T& fel);

template<class T>
void glob_pilfer(AbsList<T>&, const AbsList<T>&);




template<class T>class AbsListNode

{
private:
  AbsList<T>* head_node;
  AbsListNode<T>* prev_node;
  AbsListNode<T>* next_node;
  AbsListNode(const AbsListNode<T>& f);

  AbsListNode<T>& operator=(const AbsListNode<T>& f) {return *this;}

public:
  T el;


  inline AbsList<T>* get_head_node(void) const {return head_node;}
  inline AbsListNode<T>* get_prev_node(void) const {return prev_node;}
  inline AbsListNode<T>* get_next_node(void) const {return next_node;}



private:


  AbsListNode(AbsList<T>* fhead_node,
       AbsListNode<T>* fprev_node,
       AbsListNode<T>* fnext_node, const T& fel);
public:
  void exclude(void);
  virtual ~AbsListNode()
    {
      exclude();
    }
  friend AbsListNode<T>* glob_insert_before<>
  (AbsList<T>&, AbsListNode<T>*, const T& fel);
  friend AbsListNode<T>* glob_insert_after<>
  (AbsList<T>&, AbsListNode<T>*, const T& fel);
  friend void glob_pilfer<>(AbsList<T>&, const AbsList<T>&);
};




template<class T>class AbsList

{
private:
  mutable AbsListNode<T>* first_node;
  mutable AbsListNode<T>* last_node;
  mutable long qel;
public:
  AbsList<T>(void): first_node(NULL), last_node(NULL), qel(0) {;}
  AbsList<T>(const T& fel): first_node(NULL), last_node(NULL), qel(0)
    { insert_after(NULL, fel); }

  inline AbsListNode<T>* get_first_node(void) const
    {return first_node;}
  inline AbsListNode<T>* get_last_node(void) const {return last_node;}
  inline AbsListNode<T>* get_next_node(AbsListNode<T>* an) const
    {if(an == NULL) return first_node; else return an->get_next_node();}
  inline AbsListNode<T>* get_prev_node(AbsListNode<T>* an) const
    {if(an == NULL) return last_node; else return an->get_prev_node();}







  inline AbsListNode<T>* insert_before(AbsListNode<T>*, const T& fel);
  inline AbsListNode<T>* insert_after(AbsListNode<T>* an, const T& fel);




  friend AbsListNode<T>* glob_insert_before<>
  (AbsList<T>&, AbsListNode<T>*, const T& fel);
  friend AbsListNode<T>* glob_insert_after<>
  (AbsList<T>&, AbsListNode<T>*, const T& fel);
  friend void glob_pilfer<>(AbsList<T>&, const AbsList<T>&);




  AbsListNode<T>* push_front(const T& fel){ return insert_before(first_node, fel); }
  AbsListNode<T>* prepend(const T& fel){ return push_front(fel);}
  AbsListNode<T>* push_back(const T& fel){ return insert_after(last_node, fel); }
  AbsListNode<T>* append(const T& fel){ return push_back(fel);}

  void erase(AbsListNode<T>* an);
  inline void remove(AbsListNode<T>* an){ erase(an); }
  void remove(const T& t);

  void remove_all(const T& t);


  inline void clear(void)
    {while( first_node != NULL )
    {
    erase(first_node); }; }


  long get_qel(void) const {return qel;}
  AbsList(const AbsList<T>& al):



    first_node(NULL), last_node(NULL), qel(0)
    {



      *this = al;
    }
  AbsList(const AbsList<T>& al, Pilfer):
    first_node(NULL), last_node(NULL), qel(0)
    {



      pilfer(al);
    }
  void pilfer(const AbsList<T>& al);
  AbsList<T>& operator=(const AbsList<T>& al);
  virtual ~AbsList() { clear(); }
  friend void AbsListNode<T>::exclude(void);







};

template<class T> AbsListNode<T>::AbsListNode(const AbsListNode<T>& f)



{;}

template<class T> AbsListNode<T>::AbsListNode
(AbsList<T>* fhead_node,
 AbsListNode<T>* fprev_node,
 AbsListNode<T>* fnext_node, const T& fel):
  head_node(fhead_node),
  prev_node(fprev_node), next_node(fnext_node),
  el(fel)
{

  if(fprev_node != NULL)
  {
    if(fprev_node->next_node != fnext_node )
    {
      cout<<"template<class T> AbsListNode<T>::AbsListNode<T>\n";
      cout<<"fprev_node->next_node !=  fnext_node\n";
      cout<<indn<<"fprev_node->next_node"<<"="<<noindent<<fprev_node->next_node<<", "<<"fnext_node"<<"="<<noindent<<fnext_node<<'\n'<<yesindent;;
      {cout<<FunNameStack::instance(); cout<<"File is "<<"/home/ismirnov/s06/wcpplib/safetl/AbsList.h"<<" , line number is "<<261<<'\n'; spexit_action(cout); };
    }
    fprev_node->next_node = this;
  }
  if(fnext_node != NULL)
  {
    if(fnext_node->prev_node != fprev_node )
    {
      cout<<"template<class T> AbsListNode<T>::AbsListNode<T>\n";
      cout<<"fnext_node->prev_node !=  fprev_node\n";
      cout<<indn<<"fnext_node->prev_node"<<"="<<noindent<<fnext_node->prev_node<<", "<<"fprev_node"<<"="<<noindent<<fprev_node<<'\n'<<yesindent;;
      {cout<<FunNameStack::instance(); cout<<"File is "<<"/home/ismirnov/s06/wcpplib/safetl/AbsList.h"<<" , line number is "<<272<<'\n'; spexit_action(cout); };
    }
    fnext_node->prev_node = this;
  }
}

template<class T> void AbsListNode<T>::exclude(void)


{
  if(prev_node != NULL)
    prev_node->next_node = next_node;
  if(next_node != NULL)
    next_node->prev_node = prev_node;
  if(head_node != NULL)
  {
    if(head_node->qel <= 0)
    {
      cout<<"ERROR in template<class T> void AbsListNode<T>::exclude()\n";
      cout<<"head_node->qel <= 0, contradicts to request to exclude\n";
      cout<<indn<<"head_node->qel"<<"="<<noindent<<head_node->qel<<'\n'<<yesindent;;
      {cout<<FunNameStack::instance(); cout<<"File is "<<"/home/ismirnov/s06/wcpplib/safetl/AbsList.h"<<" , line number is "<<293<<'\n'; spexit_action(cout); };
    }
    if(head_node->first_node == this)
      head_node->first_node = next_node;
    if(head_node->last_node == this)
      head_node->last_node = prev_node;
    head_node->qel--;
  }
  head_node = NULL; prev_node = NULL; next_node = NULL;
}

template<class T> AbsListNode<T>*
glob_insert_before(AbsList<T>& al, AbsListNode<T>* aln, const T& fel)
{
  AbsListNode<T>* new_aln = NULL;
  if(aln == NULL)
  {
    if(al.qel == 0)
    {
      if(al.first_node != NULL || al.last_node != NULL)
      {
 cout<<"ERROR in template<class T> AbsListNode<T>*  glob_insert_before\n";
 cout<<"qel == 0, but first_node != NULL || last_node != NULL \n";
 cout<<indn<<"al.first_node"<<"="<<noindent<<al.first_node<<'\n'<<yesindent;;
 cout<<indn<<"al.last_node"<<"="<<noindent<<al.last_node<<'\n'<<yesindent;;
 {cout<<FunNameStack::instance(); cout<<"File is "<<"/home/ismirnov/s06/wcpplib/safetl/AbsList.h"<<" , line number is "<<318<<'\n'; spexit_action(cout); };
      }
      al.first_node = new AbsListNode<T>(&al, NULL, NULL, fel);
      al.last_node = al.first_node;
      new_aln = al.first_node;
      al.qel = 1;
    }
    else
    {
      cout<<"ERROR in template<class T> AbsListNode<T>*  glob_insert_before\n";
      cout<<" aln is zero, but the list is not empty\n";
      {cout<<FunNameStack::instance(); cout<<"File is "<<"/home/ismirnov/s06/wcpplib/safetl/AbsList.h"<<" , line number is "<<329<<'\n'; spexit_action(cout); };
    }
  }
  else
  {
    if(aln->get_head_node() != &al)
    {
      cout<<"ERROR in template<class T> AbsListNode<T>*  glob_insert_before\n";
      cout<<"aln->get_head_node() != this\n";
      cout<<indn<<"aln->get_head_node()"<<"="<<noindent<<aln->get_head_node()<<", "<<"al"<<"="<<noindent<<al<<'\n'<<yesindent;;
      {cout<<FunNameStack::instance(); cout<<"File is "<<"/home/ismirnov/s06/wcpplib/safetl/AbsList.h"<<" , line number is "<<339<<'\n'; spexit_action(cout); };
    }
    else
    {
      if(al.qel <= 0)
      {
 cout<<"ERROR in template<class T> AbsListNode<T>*  glob_insert_before\n";
 cout<<"qel <= 0 but aln is not empty\n";
 cout<<indn<<"al.qel"<<"="<<noindent<<al.qel<<'\n'<<yesindent;;
 {cout<<FunNameStack::instance(); cout<<"File is "<<"/home/ismirnov/s06/wcpplib/safetl/AbsList.h"<<" , line number is "<<348<<'\n'; spexit_action(cout); };
      }
      else
      {
 new_aln = new AbsListNode<T>
   (&al, aln->get_prev_node(), aln, fel);
 if(aln == al.first_node)
 {
   al.first_node = new_aln;
 }
 al.qel++;
      }
    }
  }
  return new_aln;
}

template<class T> AbsListNode<T>* AbsList<T>::insert_before
(AbsListNode<T>* aln, const T& fel)
{
  return glob_insert_before<T>(*this, aln, fel);
}
template<class T>
AbsListNode<T>* glob_insert_after(AbsList<T>& al, AbsListNode<T>* aln, const T& fel)
{
  AbsListNode<T>* new_aln = NULL;
  if(aln == NULL)
  {
    if(al.qel == 0)
    {
      al.first_node = new AbsListNode<T>(&al, NULL, NULL, fel);
      al.last_node = al.first_node;
      new_aln = al.first_node;
      al.qel = 1;
    }
    else
    {
      cout<<"ERROR in template<class T> AbsListNode<T>* glob_insert_after\n";
      cout<<" aln is zero, but the list is not empty\n";
      {cout<<FunNameStack::instance(); cout<<"File is "<<"/home/ismirnov/s06/wcpplib/safetl/AbsList.h"<<" , line number is "<<450<<'\n'; spexit_action(cout); };
    }
  }
  else
  {
    if(aln->get_head_node() != &al)
    {
      cout<<"ERROR in template<class T> AbsListNode<T>*  glob_insert_after\n";
      cout<<"aln->get_heed_node() != this\n";
      cout<<indn<<"aln->get_head_node()"<<"="<<noindent<<aln->get_head_node()<<", "<<"&al"<<"="<<noindent<<&al<<'\n'<<yesindent;;
      {cout<<FunNameStack::instance(); cout<<"File is "<<"/home/ismirnov/s06/wcpplib/safetl/AbsList.h"<<" , line number is "<<460<<'\n'; spexit_action(cout); };
    }
    else
    {
      if(al.qel <= 0)
      {
 cout<<"ERROR in template<class T> AbsListNode<T>*  glob_insert_after\n";
 cout<<"qel <= 0 but aln is not empty\n";
 cout<<indn<<"al.qel"<<"="<<noindent<<al.qel<<'\n'<<yesindent;;
 {cout<<FunNameStack::instance(); cout<<"File is "<<"/home/ismirnov/s06/wcpplib/safetl/AbsList.h"<<" , line number is "<<469<<'\n'; spexit_action(cout); };
      }
      else
      {
 new_aln = new AbsListNode<T>
   (&al, aln, aln->get_next_node(), fel);

 if(aln == al.last_node)
 {
   al.last_node = new_aln;
 }
 al.qel++;
      }
    }
  }
  return new_aln;
}

template<class T> AbsListNode<T>* AbsList<T>::insert_after
(AbsListNode<T>* aln, const T& fel)
{
  return glob_insert_after(*this, aln, fel);
}
template<class T> void AbsList<T>::erase
(AbsListNode<T>* aln)
{
  if(aln->get_head_node() != this)
  {
    cout<<"ERROR in template<class T> void AbsList<T>::erase(...)\n";
    cout<<"aln->get_heed_node() != this\n";
    {cout<<FunNameStack::instance(); cout<<"File is "<<"/home/ismirnov/s06/wcpplib/safetl/AbsList.h"<<" , line number is "<<557<<'\n'; spexit_action(cout); };
  }
  if(qel <= 0)
  {
    cout<<"ERROR in template<class T> void AbsList<T>::erase(...)\n";
    cout<<"qel <= 0 before erase \n";
    cout<<indn<<"qel"<<"="<<noindent<<qel<<'\n'<<yesindent;;
    {cout<<FunNameStack::instance(); cout<<"File is "<<"/home/ismirnov/s06/wcpplib/safetl/AbsList.h"<<" , line number is "<<564<<'\n'; spexit_action(cout); };
  }
  delete aln;



}

template<class T> void AbsList<T>::remove(const T& t)

{
  AbsListNode<T>* an=NULL;
  while( (an = get_next_node(an)) != NULL)
  {
    if(an->el == t)
    {
      remove(an);
      break;
    }
  }
}

template<class T> void AbsList<T>::remove_all(const T& t)

{
  AbsListNode<T>* an=NULL;
  while( (an = get_next_node(an)) != NULL)
  {
    if(an->el == t)
    {
      remove(an);
    }
  }
}
template<class T>
AbsList<T>& AbsList<T>::operator=(const AbsList<T>& f)
{



  clear();
  AbsListNode<T>* aln = get_last_node();
  AbsListNode<T>* faln = f.get_first_node();
  while(faln != NULL)
  {
    insert_after(aln, faln->el);
    aln = get_last_node();
    faln = faln->get_next_node();
  }
  return *this;
}

template<class T>
void glob_pilfer(AbsList<T>& this_al, const AbsList<T>& al)
{



  if(this_al.qel != 0)
  {
    if(al.qel != 0)
    {
      cout<<"ERROR in glob_pilfer(...):\n";
      cout<<"Both the destination and source lists are not empty\n";


      {cout<<FunNameStack::instance(); cout<<"File is "<<"/home/ismirnov/s06/wcpplib/safetl/AbsList.h"<<" , line number is "<<658<<'\n'; spexit_action(cout); };
    }
    else { this_al.clear(); }
  }
  this_al.first_node = al.first_node;
  this_al.last_node = al.last_node;
  this_al.qel = al.qel;
  AbsListNode<T>* cur_node = this_al.first_node;
  while(cur_node != NULL)
  {
    cur_node->head_node = &this_al;
    cur_node = cur_node->get_next_node();
  }
  al.first_node = NULL;
  al.last_node = NULL;
  al.qel = 0;
}

template<class T> void AbsList<T>::pilfer
(const AbsList<T>& al)
{
  glob_pilfer(*this, al);
}
template<class T>
void print_AbsList(ostream& file, const AbsList<T>& f, int l)
{
  static const char* FunNameIIII="template<class T> void print_AbsList(ostream& file, const AbsList<T>& f, int l)"; FunNameWatch funnw(FunNameIIII);
  file<<indn<<"AbsList<T>: qel="<<f.get_qel()<<'\n';

  long n=0;
  indn.n+=2;
  AbsListNode<T>* aln=NULL;
  while( (aln = f.get_next_node(aln)) != NULL)
  {
    file<<indn<<"n="<<n<<" el[n]="<<noindent; aln->el.print(file, l);
    n++;
  }







  file<<yesindent;
  indn.n-=2;
}

template<class T>
void print_AbsList(ostream& file, const AbsList<T>& f)
{
  static const char* FunNameIIII="template<class T> void print_AbsList(ostream& file, const AbsList<T>& f)"; FunNameWatch funnw(FunNameIIII);
  file<<indn<<"AbsList<T>: qel="<<f.get_qel()<<'\n';

  long n=0;
  indn.n+=2;
  AbsListNode<T>* aln=NULL;
  while( (aln = f.get_next_node(aln)) != NULL)
  {
    file<<indn<<"n="<<n<<" el[n]="<<noindent; aln->el.print(file);
    n++;
  }






  file<<yesindent;
  indn.n-=2;
}

template<class T>
ostream& operator<<(ostream& file, const AbsListNode<T>& f)
{
  static const char* FunNameIIII="template<class T> ostream& operator<<(ostream& file, const AbsListNode<T>& f)"; FunNameWatch funnw(FunNameIIII);
  file<<indn<<"AbsListNode<T>:\n";
  indn.n+=2;




  file<<"Element:\n";
  file<< f.el;
  indn.n-=2;
  return file;
}

template<class T>
ostream& operator<<(ostream& file, const AbsList<T>& f)
{
  static const char* FunNameIIII="template<class T> ostream& operator<<(ostream& file, const AbsList<T>& f)"; FunNameWatch funnw(FunNameIIII);
  file<<indn<<"AbsList<T>: qel="<<f.get_qel()<<'\n';

  long n=0;
  indn.n+=2;
  AbsListNode<T>* aln=NULL;
  while( (aln = f.get_next_node(aln)) != NULL)
  {
    file<<indn<<"n="<<n<<" el[n]="<<aln->el<<'\n';
    n++;
  }







  file<<yesindent;
  indn.n-=2;
  return file;
}
const long max_size_of_extra_increment = 1000000;




template<class T>class BlkArr

{public:
  BlkArr(void): qel(0), la(), size_of_element(sizeof(T)) {;}
  explicit BlkArr(long fqel): qel(fqel), la( DynLinArr< T >(0) ),
    size_of_element(sizeof(T))
    { if(qel > 0) la.get_first_node()->el.put_qel(qel); }
  BlkArr(long fqel, const T& val): qel(fqel), la( DynLinArr< T >(0) ),
    size_of_element(sizeof(T))
    { if(qel > 0) la.get_first_node()->el.put_qel(qel, val); }
  BlkArr(long fqel, const T* ar, ArgInterp_Arr t):
    qel(fqel), la( DynLinArr< T >(0) ) ,
    size_of_element(sizeof(T))
    { if(qel > 0)

      la.get_first_node()->el.pilfer(DynLinArr< T >(qel, ar, t));
      }
  BlkArr<T>& operator=(const BlkArr<T>& f)
    {



      if(this != &f)
      {
 qel = f.qel; size_of_element=f.size_of_element;
 la=f.la;
      }
      return *this;
    }

  BlkArr(const BlkArr<T>& f):



    qel(0), la()
  {



    *this=f;
  }
  BlkArr(const BlkArr<T>& f, Pilfer):qel(f.qel),
         size_of_element(f.size_of_element),
         la(f.la,steal)
  {



    f.qel = 0; f.size_of_element = 0;
  }
  void pilfer(const BlkArr<T>& f)
  {



    if(this != &f)
    {
      if(qel != 0)
      {
 if(f.qel != 0)
 {
   cout<<"ERROR in BlkArr::pilfer(...):\n";
   cout<<"Both the destination and source arrays are not empty\n";


   {cout<<FunNameStack::instance(); cout<<"File is "<<"/home/ismirnov/s06/wcpplib/safetl/BlkArr.h"<<" , line number is "<<159<<'\n'; spexit_action(cout); };
 }
 else { la.clear(); size_of_element = 0; qel = 0; }
      }
      qel = f.qel;
      size_of_element = f.size_of_element;
      la.pilfer(f.la);
      f.qel = 0;
      f.size_of_element = 0;
    }
  }
  BlkArr& assignAll(const T& f)
    { long n; for( n=0; n<qel; n++) operator[](n)=f; return *this; }
  T& operator[](long n);
  const T& operator[](long n) const;
  T& last_el(void);
  const T& last_el(void) const ;

  long get_qel(void) const { return qel; }
  void put_qel(long fqel);
  void increment(void)
    { long q=qel+1; put_qel(q); }
  void decrement(void)
    { long q=qel-1; put_qel(q); }
  void append(const T& val)
    {
      increment(); operator[](qel-1) = val;
    }
  void print_struct(ostream& file) const;
  void allocate_block(long fqel)
    {
      la.clear();
      qel = 0;
      put_qel(fqel);
      qel=0;
    }
  void clear(void)
  {
      la.clear();
      qel = 0;
  }



  virtual ~BlkArr(void) { }
private:
  mutable long qel;
  mutable AbsList< DynLinArr<T> > la;
  mutable long size_of_element;



};

template<class T>
T& BlkArr<T>::operator[](long n)
{
  if(n<0 || n>=qel)
  {
    cout<<"T& BlkArr::operator[](long n): n is out of bounds, n="<<n
  <<" qel="<<qel<<'\n';
    {cout<<FunNameStack::instance(); cout<<"File is "<<"/home/ismirnov/s06/wcpplib/safetl/BlkArr.h"<<" , line number is "<<255<<'\n'; spexit_action(cout); };
  }
  long q;
  AbsListNode< DynLinArr<T> >*
    aln( la.get_first_node() );
  do
  {
    if((q=aln->el.get_qel()) > n)
      return aln->el.acu(n);
    else
      n -= q;
    aln = aln->get_next_node();
  }
  while( aln != NULL);
  cout<<"T& BlkArr::operator[](long n): should never happen, n="<<n
       <<" qel="<<qel<<'\n';
  {cout<<FunNameStack::instance(); cout<<"File is "<<"/home/ismirnov/s06/wcpplib/safetl/BlkArr.h"<<" , line number is "<<271<<'\n'; spexit_action(cout); };




}

template<class T>
const T& BlkArr<T>::operator[](long n) const
{
  if(n<0 || n>=qel)
  {
    cout<<"const T& BlkArr::operator[](long n): n is out of bounds, n="<<n
  <<" qel="<<qel<<'\n';
    {cout<<FunNameStack::instance(); cout<<"File is "<<"/home/ismirnov/s06/wcpplib/safetl/BlkArr.h"<<" , line number is "<<285<<'\n'; spexit_action(cout); };
  }
  long q;
  AbsListNode< DynLinArr<T> >*
    aln( la.get_first_node() );
  do
  {
    if((q=aln->el.get_qel()) > n)
      return aln->el.acu(n);
    else
      n -= q;
    aln = aln->get_next_node();
  }
  while( aln != NULL);
  cout<<"T& BlkArr::operator[](long n): should never happen, n="<<n
       <<" qel="<<qel<<'\n';
  {cout<<FunNameStack::instance(); cout<<"File is "<<"/home/ismirnov/s06/wcpplib/safetl/BlkArr.h"<<" , line number is "<<301<<'\n'; spexit_action(cout); };




}

template<class T>
T& BlkArr<T>::last_el(void)
{
  if(qel <=0 )
  {
    cout<<"T& BlkArr::last_el(): no elements in array\n"
  <<" qel="<<qel<<'\n';
    {cout<<FunNameStack::instance(); cout<<"File is "<<"/home/ismirnov/s06/wcpplib/safetl/BlkArr.h"<<" , line number is "<<315<<'\n'; spexit_action(cout); };
  }
  long q;
  AbsListNode< DynLinArr<T> >*
    aln( la.get_first_node() );
  long n = qel - 1;
  do
  {
    if((q=aln->el.get_qel()) > n)
      return aln->el.acu(n);
    else
      n -= q;
    aln = aln->get_next_node();
  }
  while( aln != NULL);
  cout<<"T& BlkArr::::last_el(): should never happen, n="<<n
       <<" qel="<<qel<<'\n';
  {cout<<FunNameStack::instance(); cout<<"File is "<<"/home/ismirnov/s06/wcpplib/safetl/BlkArr.h"<<" , line number is "<<332<<'\n'; spexit_action(cout); };




}

template<class T>
const T& BlkArr<T>::last_el(void) const
{
  if(qel <=0 )
  {
    cout<<"const T& BlkArr::last_el(): no elements in array\n"
  <<" qel="<<qel<<'\n';
    {cout<<FunNameStack::instance(); cout<<"File is "<<"/home/ismirnov/s06/wcpplib/safetl/BlkArr.h"<<" , line number is "<<346<<'\n'; spexit_action(cout); };
  }
  long q;
  AbsListNode< DynLinArr<T> >*
    aln( la.get_first_node() );
  long n = qel - 1;
  do
  {
    if((q=aln->el.get_qel()) > n)
      return aln->el.acu(n);
    else
      n -= q;
    aln = aln->get_next_node();
  }
  while( aln != NULL);
  cout<<"T& BlkArr::::last_el(): should never happen, n="<<n
       <<" qel="<<qel<<'\n';
  {cout<<FunNameStack::instance(); cout<<"File is "<<"/home/ismirnov/s06/wcpplib/safetl/BlkArr.h"<<" , line number is "<<363<<'\n'; spexit_action(cout); };




}


template<class T>
void BlkArr<T>::put_qel(long fqel)
{

  if(fqel == qel) return;
  AbsListNode< DynLinArr<T> >* aln( la.get_first_node() );
  if(aln == NULL)
  {
    la.insert_after(NULL, DynLinArr< T >(0));
    la.get_first_node()->el.put_qel(fqel);
    qel = fqel;
    return;
  }
  else
  {
    if(fqel > qel)
    {
      long fqel_res = fqel;


      if(fqel_res < 2 * qel)
      {
 long ex = 2 * qel * size_of_element;
 if(ex < max_size_of_extra_increment)
   fqel_res = 2 * qel;
 else
 {
   long q = max_size_of_extra_increment/size_of_element;
   if(q <= 0) q = 1;
   if(fqel_res - qel < q)
     fqel_res = qel + q;
 }
      }
      long q;
      long left_old_qel = qel;
      long left_new_qel = fqel;
      long left_new_qel_res = fqel_res;


      AbsListNode< DynLinArr<T> >*
 aln( la.get_first_node() );
      do
      {
 q = aln->el.get_qel();



 if(q >= left_old_qel)
 {
   if(q >= left_new_qel)
   {
     qel = fqel;
     return;
   }
   else
   {
     left_new_qel -= q;
     left_new_qel_res -= q;
     AbsListNode< DynLinArr<T> >* aln1;
     while((aln1 = aln->get_next_node()) != NULL)
     {
       aln = aln1;
       q = aln->el.get_qel();
       if(q >= left_new_qel)
       {
  qel = fqel;
  return;
       }
       left_new_qel -= q;
       left_new_qel_res -= q;
     }

     la.insert_after(aln, DynLinArr< T >(0));
     la.get_last_node()->el.put_qel(left_new_qel_res);
     qel = fqel;

     return;
   }
 }
 left_old_qel -= q;
 left_new_qel -= q;
 aln = aln->get_next_node();
      }
      while( aln != NULL);
      cout<<"BlkArr<T>::put_qel: should never happen\n";
    }
    else
    {
      long q;
      long left_old_qel = qel;
      long left_new_qel = fqel;
      AbsListNode< DynLinArr<T> >*
 aln( la.get_first_node() );
      do
      {
 q = aln->el.get_qel();
 if(q >= left_new_qel)
 {


   long n;
   for(n=left_new_qel; n < q; n++)
   {
     aln->el[n] = T();
   }
   left_old_qel -= q;

   AbsListNode< DynLinArr<T> >* aln1 = aln->get_next_node();
   if(aln1 != NULL)
   {
     if(left_new_qel != 0)
     {
       aln = aln1;
       q = aln->el.get_qel();
       if(left_old_qel > 0)
       {
  long l = left_old_qel;
  if( q < l ) l = q;
  for(n=0; n < l; n++)
  {
    aln->el[n] = T();
  }
       }
     }
     while((aln1 = aln->get_next_node()) != NULL)

     {
       la.erase(aln1);
     }
   }
   qel = fqel;
   return;
 }
 left_old_qel -= q;
 left_new_qel -= q;
 aln = aln->get_next_node();
      }
      while( aln != NULL);
      qel = fqel;
    }
  }
}

template<class T>
void BlkArr<T>::print_struct(ostream& file) const
{
  file<<indn<<"structure: qel="<<qel<<" size_of_element="<<size_of_element<<"\n";
  indn.n+=2;
  long total_q=0;
  long n=0;
  AbsListNode< DynLinArr<T> >*
    aln( la.get_first_node() );
  if(aln != NULL)
  {
    do
    {
      file<<indn<<"n="<<n<<" qel="<<aln->el.get_qel()<<'\n';
      total_q += aln->el.get_qel();
      aln = aln->get_next_node();
    }
    while( aln != NULL);
  }
  file<<indn<<"total_q="<<total_q<<'\n';
  file<<indn<<"end of structure.\n";
  indn.n-=2;
}

template<class T>
ostream& operator<<(ostream& file, const BlkArr<T>& f)
{

  file<<indn<<"BlkArr<T>: qel="<<f.get_qel()<<'\n';
  f.print_struct(file);
  long n;
  indn.n+=2;
  for( n=0; n<f.get_qel(); n++)
  {
    file<<indn<<"n="<<n<<" el[n]="<<noindent<<f[n]<<yesindent<<'\n';
  }
  file<<yesindent;
  indn.n-=2;
  return file;
}


template<class T>
void print_BlkArr(ostream& file, const DynLinArr<T>& f, int l)
{

  file<<indn<<"BlkArr<T>: qel="<<f.get_qel()<<'\n';
  f.print_struct(file);
  long n;
  indn.n+=2;
  for( n=0; n<f.get_qel(); n++)
  {
    file<<indn<<"n="<<n<<" el[n]="<<noindent; f[n].print(file, l);
  }
  file<<yesindent;
  indn.n-=2;
}


template<class T>
int operator==(const BlkArr<T>& f1, const BlkArr<T>& f2)
{
  if(f1.get_qel() != f2.get_qel()) return 0;
  long q=f1.get_qel();
  long n;
  for( n=0; n<q; n++)
  {
    if( !(f1[n] == f2[n]) ) return 0;
  }
  return 1;
}

template<class T, class P>
int apeq_mant(const BlkArr<T>& f1, const BlkArr<T>& f2, P prec)
{
  if(f1.get_qel() != f2.get_qel()) return 0;
  long q=f1.get_qel();
  long n;
  for( n=0; n<q; n++)
  {
    if( !apeq_mant(f1[n], f2[n], prec) ) return 0;
  }
  return 1;
}

template<class T>
int operator!=(const BlkArr<T>& f1, const BlkArr<T>& f2)
{
  if(f1 == f2) return 0;
  else return 1;
}

template<class T>
DynLinArr< T > convert(const BlkArr<T>& f)

{
  long q = f.get_qel();
  DynLinArr<T> temp(q);
  long n;
  for(n=0; n<q; n++)
  {
    temp[n] = f[n];
  }
  return DynLinArr< T > (temp, steal);

}
extern int s_verbouse;
extern int s_nowarnings;
extern int s_errorstr;
extern int s_help;
extern int s_copyright;
extern int s_system;
extern int s_tcsh;
extern int s_bash;
extern int s_pipe;
extern int s_link;
extern int s_fullnames;
extern int s_notdo;
extern int s_command;
extern int s_stat;

extern String total_command;
extern String main_command;
extern BlkArr< String > argument;
extern DynLinArr< char* > argument_str;



void scncurdir(long level);


extern long q_deepest_level;
extern long q_visited_dir;




extern unsigned long long int q_file_names;
extern unsigned long long int q_files;
extern unsigned long long int total_file_size;

extern BlkArr< String > visited_dir;



extern char* rundirname;
extern long q_rundirname;

extern int filedesc[2];

extern int s_filedesc;







void scncurdir(long level)
{
  ;
  level++;




  struct dirent **namelist;
  int n;
  char* dirnameh = getcwd(NULL, 0);
  if(dirnameh == NULL) { cout<<"ERROR:\n"; cout<<'\n'<<"dirnameh"<<"== NULL"<<'\n'; cout<<"dirnameh"<<'='<<(dirnameh)<<'\n'; {cout<<FunNameStack::instance(); cout<<"File is "<<"ssdir.c"<<" , line number is "<<1186<<'\n'; spexit_action(cout); }; };
  String dirname(dirnameh);
  if( s_verbouse == 1)
    cout<<"Entering       "<<dirname<<endl;
  free(dirnameh);

  String print_dirname;
  if(s_fullnames == 1)
  {
    print_dirname = dirname;
  }
  else
  {
    if(strncmp(dirname.c_str(), rundirname, q_rundirname) == 0)
    {
      if(strcmp(dirname.c_str(), rundirname ) == 0)
      {
 print_dirname = String(".");
      }
      else if(strlen(dirname.c_str()) > q_rundirname &&
       dirname.c_str()[q_rundirname] == '/')
      {

 print_dirname = String(".") +
   String(&(dirname.c_str()[q_rundirname]));
      }
      else
      {
 print_dirname = dirname;
      }
    }
    else
    {
      print_dirname = dirname;
    }
  }

  if(s_link == 1)
  {

    long m;
    for(m=0; m<visited_dir.get_qel(); m++)
    {
      if(visited_dir[m] == dirname)
      {
 if( s_verbouse == 1)
   cout<<"This directory was already visited, returning."<<endl;
 else
 {



 }


 return;
      }
    }
  }
  q_visited_dir++;
  if(q_deepest_level < level) q_deepest_level = level;


  if(s_command == 0)
  {
    cout<<print_dirname<<endl;
  }

  if(s_link == 1)
  {
    visited_dir.append(dirname);
  }
  if(s_command == 1)
  {
    if(s_system == 1)
    {
      cout<<"-->"<<print_dirname<<':'<<endl;



      system(total_command.c_str());
    }
    else if(s_pipe == 0)
    {
      cout<<"-->"<<print_dirname<<':'<<endl;
      int s_ret_fork = fork();
      if(s_ret_fork < 0) { cout<<"ERROR:\n"; cout<<'\n'<<"s_ret_fork"<<"< 0"<<'\n'; cout<<"s_ret_fork"<<'='<<(s_ret_fork)<<'\n'; {cout<<FunNameStack::instance(); cout<<"File is "<<"ssdir.c"<<" , line number is "<<1272<<'\n'; spexit_action(cout); }; };
      if(s_ret_fork > 0 )
      {





 waitpid(s_ret_fork, NULL, 0);



      }
      else if(s_ret_fork == 0 )
      {
 if(s_errorstr == 0)
 {
   int s_ret_close=0;
   s_ret_close = close(STDERR_FILENO);
   if(s_ret_close < 0) { cout<<"ERROR:\n"; cout<<'\n'<<"s_ret_close"<<"< 0"<<'\n'; cout<<"s_ret_close"<<'='<<(s_ret_close)<<'\n'; {cout<<FunNameStack::instance(); cout<<"File is "<<"ssdir.c"<<" , line number is "<<1291<<'\n'; spexit_action(cout); }; };


 }



 execvp(main_command.c_str(), &(argument_str[0]));
      }
      else
      {
 cout<<"ERROR: Fork returned wrong value\n";
 exit(1);

      }
    }
    else
    {




      int i_ret_pipe = pipe(filedesc);
      if(i_ret_pipe < 0) { cout<<"ERROR:\n"; cout<<'\n'<<"i_ret_pipe"<<"< 0"<<'\n'; cout<<"i_ret_pipe"<<'='<<(i_ret_pipe)<<'\n'; {cout<<FunNameStack::instance(); cout<<"File is "<<"ssdir.c"<<" , line number is "<<1314<<'\n'; spexit_action(cout); }; };
      s_filedesc = 1;
      if(s_filedesc != 1) { cout<<"ERROR:\n"; cout<<'\n'<<"s_filedesc"<<"!= 1"<<'\n'; cout<<"s_filedesc"<<'='<<(s_filedesc)<<'\n'; {cout<<FunNameStack::instance(); cout<<"File is "<<"ssdir.c"<<" , line number is "<<1316<<'\n'; spexit_action(cout); }; };



      int s_ret_fork;
      s_ret_fork = fork();
      if(s_ret_fork < 0) { cout<<"ERROR:\n"; cout<<'\n'<<"s_ret_fork"<<"< 0"<<'\n'; cout<<"s_ret_fork"<<'='<<(s_ret_fork)<<'\n'; {cout<<FunNameStack::instance(); cout<<"File is "<<"ssdir.c"<<" , line number is "<<1322<<'\n'; spexit_action(cout); }; };
      if(s_ret_fork == 0 )
      {



 int s_ret_dup2=0;
 s_ret_dup2 = dup2(filedesc[1], STDOUT_FILENO);
 if(s_ret_dup2 < 0) { cout<<"ERROR:\n"; cout<<'\n'<<"s_ret_dup2"<<"< 0"<<'\n'; cout<<"s_ret_dup2"<<'='<<(s_ret_dup2)<<'\n'; {cout<<FunNameStack::instance(); cout<<"File is "<<"ssdir.c"<<" , line number is "<<1330<<'\n'; spexit_action(cout); }; };

 int s_ret_close=0;
 s_ret_close = close(filedesc[0]);
 if(s_ret_close < 0) { cout<<"ERROR:\n"; cout<<'\n'<<"s_ret_close"<<"< 0"<<'\n'; cout<<"s_ret_close"<<'='<<(s_ret_close)<<'\n'; {cout<<FunNameStack::instance(); cout<<"File is "<<"ssdir.c"<<" , line number is "<<1334<<'\n'; spexit_action(cout); }; };

 s_ret_close = close(filedesc[1]);
 if(s_ret_close < 0) { cout<<"ERROR:\n"; cout<<'\n'<<"s_ret_close"<<"< 0"<<'\n'; cout<<"s_ret_close"<<'='<<(s_ret_close)<<'\n'; {cout<<FunNameStack::instance(); cout<<"File is "<<"ssdir.c"<<" , line number is "<<1337<<'\n'; spexit_action(cout); }; };

 if(s_errorstr == 0)
 {
   int s_ret_close=0;
   s_ret_close = close(STDERR_FILENO);
   if(s_ret_close < 0) { cout<<"ERROR:\n"; cout<<'\n'<<"s_ret_close"<<"< 0"<<'\n'; cout<<"s_ret_close"<<'='<<(s_ret_close)<<'\n'; {cout<<FunNameStack::instance(); cout<<"File is "<<"ssdir.c"<<" , line number is "<<1343<<'\n'; spexit_action(cout); }; };


 }



 int s_ret_execvp;
 s_ret_execvp = execvp(main_command.c_str(), &(argument_str[0]));

 cout<<"ERROR: First child process should never reach this point,\n"
      <<"since it should be replaced by execvp().\n";
 cout<<indn<<"s_ret_execvp"<<"="<<noindent<<s_ret_execvp<<'\n'<<yesindent;;
 exit(1);


      }
      else if(s_ret_fork > 0 )
      {



 int s_ret_fork2 = fork();
 if(s_ret_fork < 0) { cout<<"ERROR:\n"; cout<<'\n'<<"s_ret_fork"<<"< 0"<<'\n'; cout<<"s_ret_fork"<<'='<<(s_ret_fork)<<'\n'; {cout<<FunNameStack::instance(); cout<<"File is "<<"ssdir.c"<<" , line number is "<<1366<<'\n'; spexit_action(cout); }; };
 if(s_ret_fork2 == 0 )
 {




   int s_ret_dup2=0;
   s_ret_dup2 = dup2(filedesc[0], STDIN_FILENO);
   if(s_ret_dup2 < 0) { cout<<"ERROR:\n"; cout<<'\n'<<"s_ret_dup2"<<"< 0"<<'\n'; cout<<"s_ret_dup2"<<'='<<(s_ret_dup2)<<'\n'; {cout<<FunNameStack::instance(); cout<<"File is "<<"ssdir.c"<<" , line number is "<<1375<<'\n'; spexit_action(cout); }; };
   int s_ret_close=0;
   s_ret_close = close(filedesc[0]);
   if(s_ret_close < 0) { cout<<"ERROR:\n"; cout<<'\n'<<"s_ret_close"<<"< 0"<<'\n'; cout<<"s_ret_close"<<'='<<(s_ret_close)<<'\n'; {cout<<FunNameStack::instance(); cout<<"File is "<<"ssdir.c"<<" , line number is "<<1378<<'\n'; spexit_action(cout); }; };
   s_ret_close = close(filedesc[1]);
   if(s_ret_close < 0) { cout<<"ERROR:\n"; cout<<'\n'<<"s_ret_close"<<"< 0"<<'\n'; cout<<"s_ret_close"<<'='<<(s_ret_close)<<'\n'; {cout<<FunNameStack::instance(); cout<<"File is "<<"ssdir.c"<<" , line number is "<<1380<<'\n'; spexit_action(cout); }; };

   ostringstream ost;
   long q= 0;
   int ic;




   while((ic=cin.get())!=EOF)
   {



     ost.put(ic); q++;
   }



   if( q > 0)
   {
     cout<<"-->"<<print_dirname<<':'<<endl;
     cout<<ost.str();
     cout.flush();
   }




   exit(0);
 }
 else if(s_ret_fork2 < 0 )
 {
   cout<<"ERROR: Fork returned wrong value"<<endl;
   exit(1);

 }
 else
 {




   int s_ret_close=0;
   s_ret_close = close(filedesc[0]);
   if(s_ret_close < 0) { cout<<"ERROR:\n"; cout<<'\n'<<"s_ret_close"<<"< 0"<<'\n'; cout<<"s_ret_close"<<'='<<(s_ret_close)<<'\n'; {cout<<FunNameStack::instance(); cout<<"File is "<<"ssdir.c"<<" , line number is "<<1425<<'\n'; spexit_action(cout); }; };
   s_ret_close = close(filedesc[1]);
   if(s_ret_close < 0) { cout<<"ERROR:\n"; cout<<'\n'<<"s_ret_close"<<"< 0"<<'\n'; cout<<"s_ret_close"<<'='<<(s_ret_close)<<'\n'; {cout<<FunNameStack::instance(); cout<<"File is "<<"ssdir.c"<<" , line number is "<<1427<<'\n'; spexit_action(cout); }; };
   waitpid(s_ret_fork2, NULL, 0);
   waitpid(s_ret_fork, NULL, 0);

 }
      }
      else
      {
 cout<<"ERROR: Fork returned wrong value."<<endl;
 exit(1);

      }

    }

  }




  n = scandir(".", &namelist, 0, alphasort);
  if(n < 0)
  {

    cout<<"Cannot scan the content of directory "<<dirname<<'\n';
    cout<<"The subdirectories of it (if any) will not be searched.\n";
  }
  else
  {
    if(n < 2) { cout<<"WARNING:\n"; cout<<'\n'<<"n"<<"< 2"<<'\n'; cout<<"n"<<'='<<(n)<<'\n'; cout<<"this is strange because pseudo-directories . and .. should be always\n"; };


    q_file_names+= n<2 ? 0 : n-2;



    int q = n;
    for(n=0; n<q; n++)
    {
      String total_name = dirname + String("/") + String(namelist[n]->d_name);




      struct stat mystat;
      int i_ret;
      i_ret = lstat(namelist[n]->d_name, &mystat);
      if(i_ret != 0) { cout<<"WARNING:\n"; cout<<'\n'<<"i_ret"<<"!= 0"<<'\n'; cout<<"i_ret"<<'='<<(i_ret)<<'\n'; cout<<"n="<<n<<" namelist[n]->d_name="<<namelist[n]->d_name<<'\n'<<"The file could be deleted during directory scan\n"; };


      if(i_ret == 0)
      {
 if(s_link == 0 && ( S_ISLNK(mystat.st_mode)))
 {




 }
 else
 {
   if( !( ( S_ISDIR(mystat.st_mode)) || ( S_ISLNK(mystat.st_mode)) ))
   {




     q_files++;
     total_file_size += mystat.st_size;



   }
   else
   {

     int s_not_enter = 0;

     if( ( S_ISDIR(mystat.st_mode)) )
     {
       if((strcmp(namelist[n]->d_name, ".")) == 0 ||
   (strcmp(namelist[n]->d_name, "..")) == 0 )
       {




  s_not_enter = 1;
       }
     }
     if(s_not_enter == 0)
     {
       if( ( S_ISLNK(mystat.st_mode)) )
       {




  if( s_verbouse == 1)
    cout<<"The name "<<namelist[n]->d_name<<" is identified as link"<<endl;




  int s_ret = chdir(namelist[n]->d_name);
  if(s_ret != 0)
  {

    s_not_enter = 1;
  }
  else
  {
    if( s_verbouse == 1)
      cout<<"The name "<<namelist[n]->d_name<<" is identified as link to directory"<<endl;
  }
       }
     }
     if(s_not_enter == 0)
     {



       int s_ret = chdir(total_name.c_str());






       if(s_ret == 0)
       {



  scncurdir(level);



  int s_ret = chdir(dirname.c_str());
  if(s_ret != 0) { cout<<"ERROR:\n"; cout<<'\n'<<"s_ret"<<"!= 0"<<'\n'; cout<<"s_ret"<<'='<<(s_ret)<<'\n'; cout<<"n="<<n<<" dirname.c_str()="<<dirname.c_str()<<'\n'; {cout<<FunNameStack::instance(); cout<<"File is "<<"ssdir.c"<<" , line number is "<<1568<<'\n'; spexit_action(cout); }; };


       }
       else
       {
  cout<<"Cannot enter the directory named "<<total_name<<"\n";
  cout<<"This directory will not be searched.\n";

       }
     }
   }
 }
      }
    }
    for(n=0; n<q; n++)
    {
      free(namelist[n]);
    }
    free(namelist);



  }
  if( s_verbouse == 1)
    cout<<"Returning from "<<dirname<<endl;
}
extern DynLinArr< DynLinArr< int > > sign_of_recognized_option;

void form_sign_of_recognized_option(int argc, char *argv[],
        long argv_start_ind, long argv_aend_ind);
int find_option(int argc, char *argv[],
  char opt, long argv_start_ind, long argv_aend_ind);

int check_all_options_recognized(int argc, char *argv[],
  long argv_start_ind, long argv_aend_ind);




char* helpstring =
"Program sdir, version 2.2, 27.11.2007.\n"
"Run-time options:\n"
"The program interpret as options all words up to the first string without \"-\" \n"
"in the beginning of it.\n"
"-v : Versouse, report scanned directory names and something else.\n"
"-w : No warnings and auxiliary information, which can interfere\n"
"     if this program is run from scripts.\n"
"-e : Outputs error stream of the target command. \n"
"     Otherwise it is dumped to /dev/null,\n"
"     which is convenient for many comands in other to get rid\n"
"     of senseless statements like \"grep: No match.\"\n"
"     (which can also be issued at file name expansion by shell).\n"
"-h : Prints help and quit.\n"
"-c : Prints copyright and quit.\n"
"-s : Uses system(...) command. \n"
"     Otherwise the program will use fork(...) and execvp(...).\n"
"-t : Inserts tcsh in the beginning of the target command sent \n"
"     to system(...) or to execvp(...) depending on the precence of -s option.\n"
"     You can achieve the same effect by manual incerting \n"
"     tcsh -fc \"target command with necessary parameters\" \n"
"     Here -f is necessary to avoid execution of .tcshrc file, \n"
"     which can make scanning of large directory trees too slow.\n"
"-b : Inserts bash -c in the beginning of the target command sent \n"
"     to system(...) or to execvp(...) depending on the precence of -s option.\n"
"     You can achieve the same effect by manual incerting \n"
"     bash -c \"target command with necessary parameters\" \n"
"     (I do not know option equivalent to -f of tcsh.)\n"
"-p : Receives and filters standard output of the target command\n"
"     through pipe. Used only with fork, that is -s should not be given.\n"
"-l : Follows symbolic links. Otherwise does not follow them.\n"
"-f : Prints directory names with full path. Otherwise full path is used\n"
"     only if it differs from current directory from which the progran was\n"
"     started. This is possible if the option -l is supplied and if\n"
"     the directories contain links to outside of the tree.\n"
"-n : Only prints the header messages and do not do anything.\n"
"     Allows to check visually whether target command and arguments\n"
"     are set correctly.\n"
"-a : Prints statistics at the end (the number of directories and\n"
"     levels of directory tree visited, the number of file names, the number of files and\n"
"     their total size.)\n";


char* copyrightstring =
"Copyright (c) 2007 I. B. Smirnov\n"
"\n"
"This program can be used, copied, modified, and distributed\n"
"according to the terms of GNU General Public License version 3\n"
"published by the Free Software Foundation 29 June 2007,\n"
"and provided that the above copyright notice, this permission notice, \n"
"and notices about any modifications of the original text\n"
"appear in all copies and in supporting documentation.\n"
"The program is provided \"as is\" without express or implied warranty.\n";
int s_verbouse = 0;
int s_nowarnings = 0;
int s_errorstr = 0;
int s_help = 0;
int s_copyright = 0;
int s_system = 0;
int s_tcsh = 0;
int s_bash = 0;
int s_pipe = 0;
int s_link = 0;
int s_fullnames = 0;
int s_notdo;
int s_command = 0;
int s_stat = 0;

long q_deepest_level = 0;
long q_visited_dir = 0;
unsigned long long int q_file_names = 0;
unsigned long long int q_files = 0;
unsigned long long int total_file_size = 0;

String total_command;
String main_command;
BlkArr< String > argument;
DynLinArr< char* > argument_str;

BlkArr< String > visited_dir;

char* rundirname = NULL;
long q_rundirname = 0;

int filedesc[2];
int s_filedesc;

int main(int argc, char *argv[])
{
  ;
  long n;
  s_exit_without_core = 1;

  if(argc <= 1)
  {
  }
  else
  {
    long argv_start_ind = 1;
    long argv_aend_ind = argc;
    for(n=argv_start_ind; n<argc; n++)
    {
      if(argv[n][0] != '-')
      {
 argv_aend_ind = n;
 break;
      }
    }



    if(argv_aend_ind == argc)
    {

    }
    else
    {
      s_command = 1;

    }

    form_sign_of_recognized_option(argc, argv, argv_start_ind, argv_aend_ind);
    s_verbouse = find_option(argc, argv, 'v', argv_start_ind, argv_aend_ind);
    s_nowarnings = find_option(argc, argv, 'w', argv_start_ind, argv_aend_ind);
    s_errorstr = find_option(argc, argv, 'e', argv_start_ind, argv_aend_ind);
    s_help = find_option(argc, argv, 'h', argv_start_ind, argv_aend_ind);
    s_copyright = find_option(argc, argv, 'c', argv_start_ind, argv_aend_ind);
    s_system = find_option(argc, argv, 's', argv_start_ind, argv_aend_ind);
    s_tcsh = find_option(argc, argv, 't', argv_start_ind, argv_aend_ind);
    s_bash = find_option(argc, argv, 'b', argv_start_ind, argv_aend_ind);
    s_pipe = find_option(argc, argv, 'p', argv_start_ind, argv_aend_ind);
    s_link = find_option(argc, argv, 'l', argv_start_ind, argv_aend_ind);
    s_fullnames = find_option(argc, argv, 'f', argv_start_ind, argv_aend_ind);
    s_notdo = find_option(argc, argv, 'n', argv_start_ind, argv_aend_ind);
    s_stat = find_option(argc, argv, 'a', argv_start_ind, argv_aend_ind);

    int s_rec;
    s_rec =
      check_all_options_recognized(argc, argv, argv_start_ind, argv_aend_ind);
    if(s_rec == 0)
    {
      exit(1);

    }
    if(s_help == 1)
    {
      cout<<indn<<helpstring;
      exit(0);
    }
    if(s_copyright == 1)
    {
      cout<<indn<<copyrightstring;
      exit(0);
    }

    if(s_command == 1)
    {
      if(s_tcsh == 1)
      {
 total_command = String("tcsh -fc ");
 main_command = String("tcsh");
 if(s_system == 0)
 {
   argument.append(main_command);

 }
       argument.append(String("-fc"));
 total_command = total_command + String("\"");
 for(n=argv_aend_ind; n<argc; n++)
 {
   total_command = total_command + String(" ") + String(argv[n]);
   argument.append(String(argv[n]));
 }
 total_command = total_command + String("\"");
 if(s_nowarnings == 0)
 {
   if(argc - argv_aend_ind > 1)
   {
     cout<<"Warning: the target command and all its arguments\n"
   <<"constitute more than one argument,\n"
   <<"which might very probably be error in the case of the use of tcsh.\n";
     cout<<"It will execute only what is in the first argument.\n";
     cout<<"You might put all target command and its arguments in \"\".\n";
     cout<<"This program will continue.\n";
   }
 }
      }
      else if(s_bash == 1)
      {
 total_command = String("bash -c ");
 main_command = String("bash");
 if(s_system == 0)
 {
   argument.append(main_command);

 }
       argument.append(String("-c"));
 total_command = total_command + String("\"");
 for(n=argv_aend_ind; n<argc; n++)
 {
   total_command = total_command + String(" ") + String(argv[n]);
   argument.append(String(argv[n]));
 }
 total_command = total_command + String("\"");
 if(s_nowarnings == 0)
 {
   if(argc - argv_aend_ind > 1)
   {
     cout<<"Warning: the target command and all its arguments \n"
   <<"constitute more than one argument,\n"
   <<"which might be error in the case of the use of bash.\n";

     cout<<"You might put all target command and its arguments in \"\".\n";
     cout<<"This program will continue.\n";
   }
 }
      }
      else
      {
 for(n=argv_aend_ind; n<argc; n++)
 {
   total_command = total_command + String(" ") + String(argv[n]);
 }





 long nc;
 for( nc=0; nc<strlen(argv[argv_aend_ind]); nc++)
 {
   if(argv[argv_aend_ind][nc] == ' ')
   {


     cout<<"ERROR: The assumed command has blanks, which is the most likely "
   <<"the error,\ncaused by the use of quotas \"\".\n";
     cout<<"The assumed command (in brackets)is ["
   <<argv[argv_aend_ind]<<"].\n";
     exit(1);

   }
 }


 if(s_nowarnings == 0)
 {
   for(n=argv_aend_ind; n<argc; n++)
   {
     long nc;
     long qc = strlen(argv[n]);
     for(nc=0; nc<qc; nc++)
     {
       if(argv[n][nc] == '*')
       {
  cout<<"Warning: there is \'*\' sign in the target command or in one of the arguents.\n";
  cout<<"If it is in the target command, it is most likely the error.\n";
  cout<<"If it is in an argument, it is an error if the target command\n"
       <<"  is not a shell which expands this sign into file list.\n";
  cout<<"This program will continue."<<endl;
  goto mcont;
       }
     }
   }
 mcont: ;
 }
 main_command = String(argv[argv_aend_ind]);
 if(s_system == 0)
 {
   argument.append(main_command);

 }
 for(n=argv_aend_ind+1; n<argc; n++)
 {
   argument.append(String(argv[n]));
 }
      }
      if(s_errorstr == 0)
      {
 total_command = total_command + String(" 2>/dev/null");
      }
      argument_str.put_qel(argument.get_qel() + 1);
      for(n=0; n<argument.get_qel(); n++)
      {
 argument_str[n] = &(argument[n][0]);
      }
      argument_str[n] = NULL;
      if(s_nowarnings == 0)
      {
 if(s_system == 1)
 {
   cout<<"Will execute system("<<total_command<<")"<<endl;
 }
 else
 {
   cout<<"Will execute fork() and execvp("<<main_command<<", args) with arguments:\n";
   indn.n+=2;
   for(n=0; n<argument_str.get_qel(); n++)
   {
     cout<<indn<<"n"<<"="<<noindent<<n<<yesindent;;
     if(argument_str[n] != NULL)
     {
       cout<<' '<<argument_str[n];
     }
     else
     {
       cout<<" NULL";
     }
     cout<<endl;
   }
   indn.n-=2;
   if(s_pipe == 1)
   {
     cout<<"Will use pipe and print directory names only if\n"
   <<"  the output of target command to standard output stream is not empty."<<endl;
   }
   if(s_errorstr == 0)
   {
     cout<<"The error stream of the target command will be dumped to /dev/null."<<endl;
   }
 }
 cout<<indn<<"Output (if any) will be started after the blank line.\n";
 cout<<endl;
      }
    }
    if(s_verbouse == 1)
    {
      cout<<indn<<"sdir: s_verbouse == 1, prints the initial setup and the command:\n";
      indn.n+=2;
      if(s_errorstr == 1)
      {
 cout<<indn<<"The error stream will be printed."<<endl;
      }
      else
      {
 cout<<indn<<"The error stream will be dumped to /dev/null."<<endl;
      }
      if(s_system == 1)
      {
 cout<<indn<<"The command \"system()\" will be used. The fork() will not be used"<<endl;
      }
      else
      {
 cout<<indn<<"The command \"system()\" will not be used. The fork() will be used instead."<<endl;
      }
      if(s_tcsh == 1)
      {
 cout<<indn<<"The command will be prepended by \"tcsh -fc\"."<<endl;
      }
      else
      {
 cout<<indn<<"The command will not be prepended by \"tcsh -fc\"."<<endl;
      }
      if(s_bash == 1)
      {
 cout<<indn<<"The command will be prepended by \"bash -c\"."<<endl;
      }
      else
      {
 cout<<indn<<"The command will not be prepended by \"bash -c\"."<<endl;
      }
      if(s_pipe == 1)
      {
 cout<<indn<<"Pipe will be used and the command stardard output will be send through it."<<endl;
      }
      else
      {
 cout<<indn<<"Pipe will not be used."<<endl;
      }
      if(s_link == 1)
      {
 cout<<indn<<"Will follow links."<<endl;
      }
      else
      {
 cout<<indn<<"Will not follow links."<<endl;
      }
      if(s_fullnames == 1)
      {
 cout<<indn<<"Will print directory names with full path."<<endl;
      }
      else
      {
 cout<<indn<<"Will not print directory names with full path."<<endl;
      }
      if(s_notdo == 1)
      {
 cout<<indn<<"The actual work will not be initiated."<<endl;
      }
      if(s_stat == 1)
      {
 cout<<indn<<"The statistics will be printed."<<endl;
      }
      if(s_command == 1)
      {
 cout<<indn<<"The command is not empty.\n";
 cout<<indn<<"The total command is:\n";
 cout<<indn<<"total_command"<<"="<<noindent<<total_command<<'\n'<<yesindent;;
 cout<<indn<<"The main or head command is recognized as follows:\n";
 cout<<indn<<"main_command"<<"="<<noindent<<main_command<<'\n'<<yesindent;;
 cout<<indn<<"The full list of arguments is the following:\n";
 indn.n+=2;
 for(n=0; n<argument_str.get_qel(); n++)
 {
   cout<<indn<<"n"<<"="<<noindent<<n<<yesindent;;
   if(argument_str[n] != NULL)
   {
     cout<<' '<<argument_str[n];
   }
   else
   {
     cout<<" NULL";
   }
   cout<<endl;
 }
 indn.n-=2;
      }
      else
      {
 cout<<indn<<"The command is empty."<<endl;
      }
      indn.n-=2;
    }
    if(s_system == 1 && s_pipe == 1)
    {
      cout<<"Error in sdir: -s and -p options are not compatible.\n";
      exit(1);
    }
    if(s_tcsh == 1 && s_bash == 1)
    {
      cout<<"Error in sdir: -t and -b options are not compatible.\n";
      exit(1);
    }

    if(s_notdo == 1)
    {
      cout<<"sdir: not doing anything because s_notdo == 1\n";
      return 0;
    }
  }
  unsigned long level = 0;

  rundirname = getcwd(NULL, 0);
  q_rundirname = strlen(rundirname);
  scncurdir(level);

  free(rundirname);

  if(s_stat == 1)
  {
    cout<<'\n'<<"Statistics recorded by sdir:\n";
    cout<<q_visited_dir<<" directories at "<<q_deepest_level
  <<" levels were visited.\n";
    cout<<q_file_names << " file names where seen \n"
  <<"  (including the directory names and links, \n"
  <<"   but not including \".\" and \"..\" symbols).\n";
    cout<< q_files << " real files (not links or directories) were met.\n";

    cout<<"Their total size is "<< total_file_size <<" bytes";
    if(total_file_size > 1000000)
    {
      cout<<" or "<< double(total_file_size) / 1000000 <<" Mbytes.\n";
    }
    else
    {
      cout<<".\n";
    }
  }
  return 0;
}
DynLinArr< DynLinArr< int > > sign_of_recognized_option;

void form_sign_of_recognized_option(int argc, char *argv[], long argv_start_ind, long argv_aend_ind)
{
  static const char* FunNameIIII="void form_sign_of_recognized_option(int argc, char *argv[], long argv_start_ind, long argv_aend_ind)"; FunNameWatch funnw(FunNameIIII);
  if(argv_start_ind < 1) { cout<<"ERROR:\n"; cout<<'\n'<<"argv_start_ind"<<"< 1"<<'\n'; cout<<"argv_start_ind"<<'='<<(argv_start_ind)<<'\n'; {cout<<FunNameStack::instance(); cout<<"File is "<<"ssdir.c"<<" , line number is "<<2199<<'\n'; spexit_action(cout); }; };
  if(argv_aend_ind < 1) { cout<<"ERROR:\n"; cout<<'\n'<<"argv_aend_ind"<<"< 1"<<'\n'; cout<<"argv_aend_ind"<<'='<<(argv_aend_ind)<<'\n'; {cout<<FunNameStack::instance(); cout<<"File is "<<"ssdir.c"<<" , line number is "<<2200<<'\n'; spexit_action(cout); }; };
  if(argv_start_ind > argv_aend_ind) { cout<<"ERROR:\n"; cout<<'\n'<<"argv_start_ind"<<">"<<"argv_aend_ind"<<'\n'; cout<<"argv_start_ind"<<'='<<(argv_start_ind)<<' '<<"argv_aend_ind"<<'='<<(argv_aend_ind)<<'\n'; {cout<<FunNameStack::instance(); cout<<"File is "<<"ssdir.c"<<" , line number is "<<2201<<'\n'; spexit_action(cout); }; };
  if(argv_aend_ind > argc) { cout<<"ERROR:\n"; cout<<'\n'<<"argv_aend_ind"<<">"<<"argc"<<'\n'; cout<<"argv_aend_ind"<<'='<<(argv_aend_ind)<<' '<<"argc"<<'='<<(argc)<<'\n'; {cout<<FunNameStack::instance(); cout<<"File is "<<"ssdir.c"<<" , line number is "<<2202<<'\n'; spexit_action(cout); }; };
  sign_of_recognized_option.pilfer(DynLinArr< DynLinArr< int > >
       (argv_aend_ind - argv_start_ind));
  long na;
  long nc;
  for(na = argv_start_ind; na < argv_aend_ind; na++)
  {
    sign_of_recognized_option[na - argv_start_ind].
      pilfer(DynLinArr< int >((strlen(argv[na]) - 1), 0));
  }




}



int find_option(int argc, char *argv[],
  char opt, long argv_start_ind, long argv_aend_ind)
{
  ;
  if(argv_start_ind < 1) { cout<<"ERROR:\n"; cout<<'\n'<<"argv_start_ind"<<"< 1"<<'\n'; cout<<"argv_start_ind"<<'='<<(argv_start_ind)<<'\n'; {cout<<FunNameStack::instance(); cout<<"File is "<<"ssdir.c"<<" , line number is "<<2224<<'\n'; spexit_action(cout); }; };
  if(argv_aend_ind < 1) { cout<<"ERROR:\n"; cout<<'\n'<<"argv_aend_ind"<<"< 1"<<'\n'; cout<<"argv_aend_ind"<<'='<<(argv_aend_ind)<<'\n'; {cout<<FunNameStack::instance(); cout<<"File is "<<"ssdir.c"<<" , line number is "<<2225<<'\n'; spexit_action(cout); }; };
  if(argv_start_ind > argv_aend_ind) { cout<<"ERROR:\n"; cout<<'\n'<<"argv_start_ind"<<">"<<"argv_aend_ind"<<'\n'; cout<<"argv_start_ind"<<'='<<(argv_start_ind)<<' '<<"argv_aend_ind"<<'='<<(argv_aend_ind)<<'\n'; {cout<<FunNameStack::instance(); cout<<"File is "<<"ssdir.c"<<" , line number is "<<2226<<'\n'; spexit_action(cout); }; };
  if(argv_aend_ind > argc) { cout<<"ERROR:\n"; cout<<'\n'<<"argv_aend_ind"<<">"<<"argc"<<'\n'; cout<<"argv_aend_ind"<<'='<<(argv_aend_ind)<<' '<<"argc"<<'='<<(argc)<<'\n'; {cout<<FunNameStack::instance(); cout<<"File is "<<"ssdir.c"<<" , line number is "<<2227<<'\n'; spexit_action(cout); }; };

  long na;
  long nc;
  for(na = argv_start_ind; na < argv_aend_ind; na++)
  {
    for(nc=1; nc<strlen(argv[na]); nc++)
    {
      if(argv[na][nc]==opt)
      {
 sign_of_recognized_option[na - argv_start_ind][nc-1] = 1;
 return 1;
      }
    }
  }
  return 0;
}

int check_all_options_recognized(int argc, char *argv[],
  long argv_start_ind, long argv_aend_ind)
{
  ;




  int s_good = 1;
  long na;
  long nc;
  for(na = argv_start_ind; na < argv_aend_ind; na++)
  {
    for(nc=1; nc<strlen(argv[na]); nc++)
    {
      if(sign_of_recognized_option[na - argv_start_ind][nc-1] == 0)
      {
 cout<<"Error: option "<<argv[na][nc]<<" is not recognized\n";
 s_good = 0;
      }
    }
  }
  return s_good;
}
